SystemOrganization addCategory: #'CAs-Pirate'!
SystemOrganization addCategory: #'CAs-Pirate-Gui'!
SystemOrganization addCategory: #'CAs-Pirate-Web'!

!OSProcess class methodsFor: '*CAs-Pirate' stamp: 'ChristerAssmundsson 5/21/2014 10:45'!
platformName 
	"After Squeak version 3.6, #platformName was moved to SmalltalkImage Some
	versions of Pharo move this to OSPlatform and issue deprecation warnings
	about the other usages. The original idiom (Squeak 3.6 and earlier) is the sensible
	default, but here we attempt to support other implementations if the sensible
	default is not available.
	'Sensible default' brings up six deprecation warnings for every save, so avoid that"

	"OSProcess platformName"

	((Smalltalk respondsTo: #platformName) and: [ self isPharo2AndLater not ])
		ifTrue: [^ Smalltalk platformName].
	self isPharo3AndLater
		ifTrue: [ ^ (Smalltalk perform: #os) name ].
	^ (((Smalltalk hasClassNamed: #OSPlatform)
			and: [(Smalltalk at: #OSPlatform)
					respondsTo: #platformName])
		ifTrue: [Smalltalk at: #OSPlatform]
		ifFalse: [((Smalltalk classNamed: 'SmalltalkImage')
				ifNil: [^ Smalltalk osVersion]) current]) platformName! !

WRHttpRobot subclass: #PirateRobot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'CAs 2/5/2012 09:41'!
foundEpisodes
	| episodes found |
	episodes := #(
		'Chuck%20S05E09'
		'Chuck%20S05E19' 
		 'Big Bang%20S05E11'
		 'Big Bang%20S05E22').
	found := episodes select: [:e| self foundShow: e].
	^found! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/6/2012 20:46'!
foundShow: aShow 
	| found |
	"Transcript show: 'Looking for ', aShow."
	found := (self getShow: aShow) isEmpty not.
	found ifTrue: [Transcript show: aShow , ' - Found!!'.Transcript cr.].
	
	^ found.! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/11/2013 06:54'!
getMovie: aString 
	| main rows baseUrl suffix searchRows dud |
	
	^self getTorrents: aString category: '201,202,207'.
	! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/10/2013 02:35'!
getShow: aString 
	^self getTorrents: aString category: '205,208'.
! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/12/2013 19:57'!
getShowImage: aShowname 
"not working"
	| main rows baseUrl suffix searchRows dud aString |
	baseUrl := 'http://www.addic7ed.com/images/showimages/'.
	suffix := '.jpg'.
	aString:= self removeBlanksFrom: (aShowname asLowercase).
	[self newGet: baseUrl , aString , suffix]
		on: Exception
		do: [Transcript show: 'Exception on newGet';
				 cr.
			self halt].
	self checkOk.
	"Parse page"
	self parseBody.
	dud := (dom tagOfClass: HtmlH2Node) children second innerContents.
	(dud findString: 'No hits')
			> 0
		ifTrue: [^ Array new].
	main := dom tagWithId: 'searchResult'.
	searchRows := main tagsOfClass: HtmlTRNode.
	rows := self parseRows: searchRows allButFirst.
	^ rows! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'CAs 6/22/2012 00:32'!
getSubtitle: aString 
	| main rows baseUrl suffix searchRows dud |
	baseUrl := 'http://http://www.addic7ed.com/serie/'.
	suffix := '/1'.
	[self newGet: baseUrl , aString , suffix]
		on: Exception
		do: [Transcript show: 'Exception on newGet';
				 cr.
			self halt].
	self checkOk.
	"Parse page"
	self parseBody.
	dud := (dom tagOfClass: HtmlH2Node) children second innerContents.
	(dud findString: 'No hits')
			> 0
		ifTrue: [^ Array new].
	main := dom tagWithId: 'searchResult'.
	searchRows := main tagsOfClass: HtmlTRNode.
	rows := self parseRows: searchRows allButFirst.
	^ rows! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'CAs 6/25/2012 09:48'!
getSubtitles: aString 
	| rows baseUrl suffix searchRows dud |
	baseUrl := 'http://www.addic7ed.com/serie/'.
	suffix := '/1'.
	[self newGet: baseUrl , aString , suffix]
		on: Exception
		do: [Transcript show: 'Exception on newGet';
				 cr.
			self halt].
	self checkOk.
	"Parse page"
	self parseBody.
	dud := (dom tagWithId: 'container95m') innerContents.
	"children second"
	(dud findString: 'Filter ignored')
			> 0
		ifTrue: [^ Array new].
	searchRows := dom tagsWithId: 'container95m'.
	rows := self parseSubs: searchRows.
	^ rows! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/12/2013 19:56'!
getTest
	| |
	^self getShow: 'haven%20s02*'.
! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'CAs 2/5/2012 09:00'!
getTest: aString
	| main rows baseUrl suffix searchRows dud |
	baseUrl := 'http://thepiratebay.org/search/'.
	suffix := '/0/9/205,208'.
	self newGet: (baseUrl , aString , suffix ).
	self checkOk.
	
	"Parse page"
	self parseBody.
	dud := (dom tagOfClass: HtmlH2Node) children second innerContents.
	((dud findString: 'No hits') >0) ifTrue: [^Array new].
	main := dom tagWithId: 'searchResult'.
"	sidorHtml := main tagWithId: 'all_pages'."
"	main := main tagWithClass: 'list_mode_thumb'."
	searchRows := main tagsOfClass: HtmlTRNode.
	rows := self parseRows: (searchRows allButFirst) .
"	rowsSorted := rows sort: [:a :b | (a third >= b third)]."
"self halt."
	^rows
	"
	(request url urlString includesSubString: 'WeAreClosed') ifTrue: [self error: 'Closed'].
	form := dom tagWithId: 'loginForm'.
		""Send a post to actually login""
	request openPostTo: form action.
	fields := Dictionary new.

	""Build request""
	request addHeader: 'Content-Type' value: 'application/x-www-form-urlencoded'.
	request entityString: (self argString: fields).

	(request responseBody includesSubString: 'You did something wrong') ifTrue: [self error: 'Something went wrong'].
"! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/8/2014 21:07'!
getTorrents: aString category: categoryString
	| main rows baseUrl suffix searchRows dud |
	baseUrl := 'http://thepiratebay.org/search/'.
	"baseUrl := 'http://pirateproxy.se/search/'."
	suffix := '/0/7/' , categoryString.
	[self newGet: baseUrl , aString , suffix]
		on: Exception
		do: [Transcript show: 'Exception on newGet';
				 cr.
			^OrderedCollection new.].
	self checkOk.
	"Parse page"
	self parseBody.
	dud := (dom tagOfClass: HtmlH2Node) children second innerContents.
	(dud findString: 'No hits')
			> 0
		ifTrue: [^ Array new].
	main := dom tagWithId: 'searchResult'.
	searchRows := (main tagsOfClass: HtmlTRNode).
	searchRows := main children.
	rows := self parseRows: searchRows allButFirst.
	^ rows! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'CAs 7/9/2012 02:42'!
parseRows: fullHtml 
	| rows title cell2 leechers seeders torrent magnet |
	rows := OrderedCollection new.
	fullHtml
		do: [:html | 
			cell2 := html children second.
			title := cell2 children first children first innerContents.
			torrent := cell2 children second href.
			seeders := html children third innerContents asInteger.
			leechers := html children fourth innerContents asInteger.
			rows
				add: (Array
						with: title
						with: torrent
						with: seeders
						with: leechers)].
	"rows first inspect."
	"self halt."
	^ rows! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'CAs 6/25/2012 11:50'!
parseSubs: allSubRows 
	| rows title dl hi lang imgs |
	rows := OrderedCollection new.

	allSubRows
		do: [:html | (html tagWithClass: 'NewsTitle') isNil
				ifFalse: [title := (html tagWithClass: 'NewsTitle') children second innerContents.
					lang := (html tagWithClass: 'language') children first innerContents.
					imgs := html tagsOfClass: HtmlIMGNode.
					hi := imgs
								anySatisfy: [:i | i src = 'http://www.addic7ed.com/images/hi.jpg'].
					dl := (html tagWithClass: 'buttonDownload') href.
					rows
						add: (Array
								with: title
								with: lang
								with: hi 
								with: dl)]].
	"rows first inspect."
	"self halt."
	^ rows! !

!PirateRobot methodsFor: 'as yet unclassified' stamp: 'CAs 6/22/2012 11:49'!
removeBlanksFrom: aString 
	| s |
	s := String writeStream.
	aString
		do: [:c | c = Character space
				ifFalse: [s nextPut: c]].
	^ s contents! !

BlocketRootMorph subclass: #PirateEpisodeMorph
	instanceVariableNames: 'model allTorrents torrents listIndex torrentsSwe listIndexSwe listIndexInvalids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 9/5/2012 07:10'!
addControls
	| r lst btnPanel |
	self
		addMorphBack: (StringMorph contents: 'Title: ').
	"self
	addMorph: (PluggableTextMorph
	on: nil
	text: #getTitle
	accept: #setTitle)."
	lst := PluggableMultiColumnListMorph
				on: self
				list: #list
				selected: #listIndex
				changeSelected: #listIndex:.
		"		menu: #listMenu:."
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getTorrentText:  .
	lst color: Color white.
	lst extent: 500 @ 130.
	self addMorphBack: lst.
	lst := PluggableMultiColumnListMorph
				on: self
				list: #listSwe
				selected: #listIndexSwe
				changeSelected: #listIndexSwe: .
		"		menu: #listMenu:."
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getTorrentText:  .
	lst color: Color white.
	lst extent: 500 @ 130.
	self addMorphBack: lst.
	btnPanel := self newRow.
	btnPanel color: Color transparent;
		 borderWidth: 0;
		 layoutInset: 2;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	self addMorphBack: btnPanel.
	btnPanel
		addMorphBack: (self newButton: 'Refresh.' do: #refreshTorrents).
	btnPanel
		addMorphBack: (self newButton: 'Manual download' do: #manualDownload).
	btnPanel
		addMorphBack: (self newButton: 'Download' do: #download).
	btnPanel
		addMorphBack: (self newButton: 'Remove files' do: #removeFiles).
	btnPanel
		addMorphBack: (self newButton: 'Set Torrent' do: #setTorrent).btnPanel
		addMorphBack: (self newButton: 'Subtitles...' do: #subtitles).
	btnPanel
		addMorphBack: (self newButton: 'findTorrent.' do: #findCurrentTorrent).
	btnPanel
		addMorphBack: (self newButton: 'Invalid Torrent' do: #invalidTorrent).
	lst := PluggableMultiColumnListMorph
				on: self
				list: #listInvalids
				selected: #listIndexInvalids
				changeSelected: #listIndexInvalids:
				menu: #listMenu:.
	lst doubleClickSelector: #dblClickInvalids.
	lst wrapSelector: #getTorrentText:  .
	lst color: Color gray.
	lst extent: 500 @ 130.
	self addMorphBack: lst.
	self
		addMorphBack: (self newButton: 'Remove invalid' do: #removeInvalid).
	"------------------------------------"
	r := AlignmentMorph newRow color: Color transparent;
				 borderWidth: 0;
				 layoutInset: 0.
	r wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	r
		addMorphBack: (self newButton: 'Close' do: #delete).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphFront: r! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'CAs 7/28/2012 08:52'!
dblClick
	self setTorrent.
	self delete.! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'CAs 6/19/2012 23:01'!
download
	model isDownloaded
		ifFalse: [model download]
		ifTrue: [^ self]! !

!PirateEpisodeMorph methodsFor: 'dropping/grabbing' stamp: 'CAs 6/23/2012 10:36'!
dropFiles: anEvent 
| |
	Transcript show: 'Dropped files';cr.
	
"	numFiles := anEvent contents.
	1 to: numFiles do: [ :i |
		(stream := FileStream requestDropStream: i) ifNotNil: [
			handler := ExternalDropHandler lookupExternalDropHandler: stream.
			[ handler ifNotNil: [handler handle: stream in: self dropEvent: anEvent ] ]
				ensure: [ stream close ] ] ]."

	^self.! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'CAs 6/22/2012 11:13'!
findCurrentTorrent
	| torrent m |
	torrent := model magnet.
	torrent isEmptyOrNil
		ifTrue: [^ self].
	1
		to: torrents size
		do: [:i | 
			m := torrents at: i.
			torrent
					= (m at: 2)
				ifTrue: [self listIndex: i]].
1
		to: torrentsSwe size
		do: [:i | 
			m := torrentsSwe at: i.
			torrent
					= (m at: 2)
				ifTrue: [self listIndexSwe:i]].
! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/31/2014 23:19'!
getTorrentText: aTorrent
	aTorrent class =String ifTrue: [^aTorrent].
	^ {aTorrent at: 1. (aTorrent at: 3) asString. (aTorrent at: 4) asString}! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 9/3/2012 07:28'!
getTorrents
	| |
	model
		ifNil: [^ self].
	[allTorrents := model torrents.
	torrents :=allTorrents
				reject: [:i | (i at: 1)
						includesSubstring: 'swesub'
						caseSensitive: false].
	self changed: #list.
	listIndex := 0.
	torrentsSwe := allTorrents
				select: [:i | (i at: 1)
						includesSubstring: 'swesub'
						caseSensitive: false].
	self changed: #listSwe.
	listIndexSwe := 0.
	self changed: #listInvalids.
	listIndexInvalids := 0.
	WorldState
		addDeferredUIMessage: [self findCurrentTorrent]] fork! !

!PirateEpisodeMorph methodsFor: 'initialization' stamp: 'CAs 7/6/2012 09:34'!
initialize
	model := nil.
	super initialize.
"	self enableDrop: true."
"	self highlightForDrop"! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 9/3/2012 07:28'!
invalidTorrent
	 | t |
	self listIndex > 0
		ifTrue: [t := torrents at: listIndex].
	self listIndexSwe > 0
		ifTrue: [t := torrentsSwe at: listIndexSwe].
	t isNil
		ifFalse: [model addFalseTorrent: t.
			self getTorrents]! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 7/9/2012 02:47'!
list
	| |
	torrents
		ifNil: [^ nil].
	torrents isEmpty
		ifTrue: [^ nil].
	
	"^ #(1 3 4 )
		collect: [:f | torrents
				collect: [:i | i at: f]]"
			^torrents! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 5/17/2012 21:42'!
listIndex
	^ listIndex
		ifNil: [listIndex := 0]! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 6/22/2012 10:28'!
listIndex: aSmallInteger 
	listIndex := aSmallInteger.
	self changed: #listIndex.
	listIndexSwe:=0.self changed: #listIndexSwe.! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 07:26'!
listIndexInvalids
	^ listIndexInvalids
		ifNil: [listIndexInvalids := 0]! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 6/17/2012 11:26'!
listIndexInvalids: aSmallInteger 
	listIndexInvalids := aSmallInteger.
	self changed: #listIndex! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 6/22/2012 00:08'!
listIndexSwe
	^ listIndexSwe
		ifNil: [listIndexSwe := 0]! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 6/22/2012 10:29'!
listIndexSwe: aSmallInteger 
	listIndexSwe := aSmallInteger.
	self changed: #listIndexSwe.	listIndex := 0.
	self changed: #listIndex.! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 07:25'!
listInvalids
	model 
		ifNil: [^ nil].
	model falseTorrents isEmpty
		ifTrue: [^ nil].
	^model falseTorrents! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 7/22/2012 10:32'!
listSwe
	| |
	torrentsSwe
		ifNil: [^ nil].
	torrentsSwe isEmpty
		ifTrue: [^ nil].

"	^ #(1 3 4 )
		collect: [:f | torrentsSwe
				collect: [:i | i at: f]]."
			^torrentsSwe! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'CAs 6/18/2012 07:46'!
manualDownload
	model torrent: #dummyTorrent! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 07:27'!
model: anEpisode 
	model := anEpisode.
	self getTorrents! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 1/31/2014 23:50'!
refreshTorrents
	model lookForIt. 
	self getTorrents.! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'CAs 6/19/2012 22:06'!
removeFiles

	model isDownloaded
		ifTrue: [model removeTorrentAndData]
		ifFalse: [^ self]! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 9/3/2012 07:30'!
removeInvalid
	 | t |
	self listIndexInvalids > 0
		ifTrue: [t := model falseTorrents at: listIndexInvalids].
	t isNil
		ifFalse: [model removeFalseTorrent: t.
			self getTorrents]! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 9/9/2012 09:33'!
setTorrent
	| t |
	self listIndex > 0
		ifTrue: [t := torrents at: listIndex].
	self listIndexSwe > 0
		ifTrue: [t := torrentsSwe at: listIndexSwe].
	t isNil
		ifFalse: [model torrent: t;
				 download.
				self listIndexSwe > 0
					ifTrue: [model setSub: 'dummy'].]! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 11/3/2012 20:44'!
subtitles
| m |
m:=PirateSubtitleMorph new.

			m model: ( model).
			m openInWorld! !

!PirateEpisodeMorph methodsFor: 'dropping/grabbing' stamp: 'CAs 6/23/2012 10:35'!
wantsDropFiles: anEvent 
	^ true! !

!PirateEpisodeMorph methodsFor: 'dropping/grabbing' stamp: 'CAs 7/11/2012 20:25'!
wantsDroppedMorph: aMorph event: anEvent
	^false! !

BlocketRootMorph subclass: #PirateManagerMorph
	instanceVariableNames: 'list listIndex model listIndex2 model2 model3 listIndex3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateManagerMorph methodsFor: 'initialize-release' stamp: 'ChristerAssmundsson 3/15/2015 10:59'!
addControls
	| bb r lst lst2 lst3 r1 r2 r3 r1c2 r2c2 r3c2 listboxWidth |
	listboxWidth := 350.
	r1 := self newRow.
	r1c2 := r1 class newColumn.
	r2 := self newRow.
	r2c2 := r1 class newColumn.
	r3 := self newRow.
	r3c2 := r1 class newColumn.
	lst := PluggableMultiColumnListMorph
				on: self
				list: #list
				selected: #listIndex
				changeSelected: #listIndex: .
			"	menu: #listMenu:."
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getShowText: .
	lst color: Color white.
	lst extent: listboxWidth @ 230.
	r1 addMorphBack: lst.
	r1c2
		addMorphBack: (self newButton: 'Add show...' do: #addShow).
	r1c2
		addMorphBack: (self newButton: 'Look for new' do: #lookForNew).
	r1c2
		addMorphBack: (self newButton: 'Remove seen' do: #removeSeen).
	r1c2
		addMorphBack: (self newButton: 'Write to file' do: #writeToFile).
	r1c2
		addMorphBack: (self newButton: 'Archive...' do: #archiveShow).
	r1c2
		addMorphBack: (self newButton: 'Delete show...' do: #deleteShow).
	r1c2
		addMorphBack: (self newButton: 'Refresh' do: #refresh).
	r1c2
		addMorphBack: (self newButton: 'New episodes' do: #newEpisodes).
	r1c2
		addMorphBack: (self newButton: 'Viewables' do: #viewables).
	r1c2
		addMorphBack: (self newButton: 'Pairing' do: #pairing).
	r1 addMorphBack: r1c2.
	lst2 := PluggableListMorph
				on: self
				list: #list2
				selected: #listIndex2
				changeSelected: #listIndex2:.
	lst2 doubleClickSelector: #dblClick2.
	lst2 wrapSelector: #getSeasonText: .
	lst2 color: Color white.
	lst2 extent: listboxWidth @ 150.
	r2 addMorphBack: lst2.
	r2c2
		addMorphBack: (self newButton: 'Add Season...' do: #addSeason).
	r2 addMorphBack: r2c2.
	lst3 := PluggableMultiColumnListMorph
				on: self
				list: #list3
				selected: #listIndex3
				changeSelected: #listIndex3:
				menu: #listMenu3:.
	lst3 doubleClickSelector: #dblClick3.
	lst3 wrapSelector: #getEpisodeText: .
	lst3 color: Color white.
	lst3 extent: listboxWidth @ 200.
	r3 addMorphBack: lst3.
	
	r3c2
		addMorphBack: (self newButton: 'Open' do: #dblClick3).
	r3c2
		addMorphBack: (self newButton: 'Add episode' do: #addEpisode).
	r3c2
		addMorphBack: (self newButton: 'Add episodes...' do: #addEpisodes).
	r3c2
		addMorphBack: (self newButton: 'Remove episode...' do: #removeEpisode).
	r3c2
		addMorphBack: (self newButton: 'Play !!!!' do: #play).
	r := AlignmentMorph newRow color: Color transparent;
				 borderWidth: 0;
				 layoutInset: 0.
	r3c2
		addMorphBack: (self newButton: 'Seen' do: #seenEpisode).
		r := AlignmentMorph newRow color: Color transparent;
				 borderWidth: 0;
				 layoutInset: 0.
	r3c2
		addMorphBack: (self newButton: 'Add videofile' do: #addVideofile).
	r3c2
		addMorphBack: (self newButton: 'Add Torrent' do: #addTorrent).
	r3 addMorphBack: r3c2.

	r wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	bb := SimpleButtonMorph new target: self;
				 borderColor: Color black.
	r
		addMorphBack: (self wrapperFor: (bb label: 'Close' translated;
					 actionSelector: #delete)).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphBack: r1.
	self addMorphBack: r2.
	self addMorphBack: r3.
	self addMorphFront: r! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 5/25/2012 06:31'!
addEpisode
	listIndex2 > 0
		ifFalse: [^ self].
	model3 addEpisode.
	self changed: #list3.
! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 7/10/2012 08:33'!
addEpisodes
		| maxNo |
	listIndex2 > 0
		ifFalse: [^ self].
		maxNo:= UIManager default request: 'Max episode number' initialAnswer: '1'.
		maxNo isNil ifTrue:[^self].
		maxNo := maxNo asInteger.
		(1+model3 maxEpisode) to: maxNo do: [:i|model3 addEpisodeNo: i] .

	self changed: #list3.
! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 5/25/2012 07:12'!
addSeason
	model2 addSeason.self changed: #list2.
			listIndex2 := 0.
			self changed: #listIndex2.
			model3 := nil.
			self changed: #list3! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 7/10/2012 18:25'!
addShow
	| name sh |
	name := UIManager default request: 'Name of new show'.
	name isEmpty
		ifFalse: [sh := PirateShow new.    
			"UserDialogBoxMorph inform: name."
			sh name: name.
			self changed: #list.
			listIndex := 0.
			self changed: #listIndex2.
			model3 := nil.
			self changed: #list3]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/18/2015 21:18'!
addTorrent
	| t mag ep |
	listIndex3 = 0
		ifTrue: [ ^ self ].
	mag := UIManager default request: 'Add torrent (Magnet link):' initialAnswer: '<Magnet link>'.
	mag isNil
		ifTrue: [ ^ self ].
	t := PirateTorrent magnet: mag.
	t isNil
		ifTrue: [ ^ self ].
	ep := model3 episodes at: listIndex3.
	ep
		torrent: t;
		download.
	self changed: #list3! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/19/2015 07:31'!
addVideofile
	| ep file vf |
	listIndex3 = 0 
		ifTrue: [ ^ self ].
file:=UITheme current 	chooseFileIn: self title: 'Select a video file' extensions: nil path: PirateTorrent folder preview: nil.
	self halt.
"	mag := UIManager default request: 'Add torrent (Magnet link):' initialAnswer: '<Magnet link>'.
"	file isNil
		ifTrue: [ ^ self ].
	vf := PirateVideoFile new.
	vf videoFilename: file basename.
	vf folder: file reference parent fullName.
	ep := model3 episodes at: listIndex3.
	ep
		videoFile: vf.
	self changed: #list3! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 5/18/2014 08:52'!
archiveShow
	listIndex > 0
		ifTrue: [ 
			(self confirm: 'Vill du verkligen arkivera programmet?' , String crlfcrlf , (self list at: listIndex) name)
				ifTrue: [ 
					(self list at: listIndex) archived: true.
					self changed: #list.
					listIndex := 0.
					self changed: #listIndex.
					model2 := nil.
					self changed: #list2.
					listIndex2 := 0.
					self changed: #listIndex2.
					model3 := nil.
					self changed: #list3 ] ]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 4/7/2014 22:17'!
dblClick
	"self inform: 'dubbelclickade'."
	listIndex > 0
		ifTrue: [
			model2 := self list at: listIndex.
			self changed: #list2.
			self listIndex2: 0.
			model3 := nil.
			self changed: #list3 ]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 9/14/2012 21:11'!
dblClick2
	"self inform: 'dubbelclickade'."
	listIndex2 > 0
		ifTrue: [model3 := model2 seasons at: listIndex2.
			self changed: #list3.		
			listIndex3 := 0.
			self changed: #listIndex3.]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 6/18/2012 07:42'!
dblClick3
	| m ep |
	listIndex3 > 0
		ifTrue: [m := PirateEpisodeMorph new.
			ep := model3 episodes at: listIndex3.
			m model: ep.
			m openInWorld.
			]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 5/18/2014 08:53'!
deleteShow
	listIndex > 0
		ifTrue: [ 
			(self confirm: 'Villdu verkligen ta bort programmet?' , String crlfcrlf , (self list at: listIndex) name)
				ifTrue: [ 
					PirateShow removeShow: (self list at: listIndex).
					self changed: #list.
					listIndex := 0.
					self changed: #listIndex.
					model2 := nil.
					self changed: #list2.
					listIndex2 := 0.
					self changed: #listIndex2.
					model3 := nil.
					self changed: #list3 ] ]! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 3/18/2015 07:37'!
getEpisodeText: anEpisode
"self halt."

	^ {(anEpisode id).
	(anEpisode found
		ifTrue: [ 'found' ]
		ifFalse: [ ' - ' ]).
	(anEpisode newFound
		ifTrue: [ 'new' ]
		ifFalse: [ ' - ' ]).	"(anEpisode isDownloaded)ifTrue:['downloaded']ifFalse:[
		anEpisode torrent isNil ifTrue: [' - '] ifFalse: ['started']]."
	(anEpisode status).
	(anEpisode statusCode printString).
	(anEpisode isViewable 
		ifTrue: [ 'viewable' ]
		ifFalse: [ ' - ' ]).
	(anEpisode hasSubtitle
		ifTrue: [ 'subs' ]
		ifFalse: [ ' - ' ]).
	(anEpisode isViewed
		ifTrue: [ 'seen' ]
		ifFalse: [ ' - ' ])}! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/14/2012 21:05'!
getSeasonText: aSeason
	^aSeason id.! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 07:09'!
getShowText: aShow
	^{
		aShow name.
		(aShow newEpisodeCount) > 0 ifTrue:['new'] ifFalse:['-'].
		(aShow notSeenCount) > 0 ifTrue:['viewable'] ifFalse:['-'].
	}! !

!PirateManagerMorph methodsFor: 'initialize-release' stamp: 'CAs 4/16/2012 07:01'!
initialize
	model := PirateShow shows.
	super initialize.
! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/31/2014 23:35'!
list
	model ifNil: [ ^ nil ].	
	^ model reject: [ :item | item archived ]! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/31/2014 23:44'!
list2
	model2
		ifNil: [^ nil].
	^model2 seasons! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/31/2014 23:45'!
list3
	model3 ifNil: [ ^ nil ].
	^ model3 episodes! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 4/16/2012 07:02'!
listIndex
	^listIndex ifNil: [listIndex:=0].! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 4/27/2012 06:59'!
listIndex2
	^ listIndex2
		ifNil: [listIndex2 := 0]! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 5/19/2012 10:50'!
listIndex2: anInteger 
	listIndex2 := anInteger.
	self changed: #listIndex2.	
		self dblClick2! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 4/30/2012 07:03'!
listIndex3
	^ listIndex3
		ifNil: [listIndex3 := 0]! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 4/30/2012 07:03'!
listIndex3: anInteger 
	listIndex3 := anInteger.
	self changed: #listIndex3! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/14/2012 21:31'!
listIndex: anInteger
	listIndex := anInteger.
	self changed: #listIndex.
	self dblClick! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 6/23/2013 15:33'!
lookForNew
	[PirateShow shows
		do: [:sh | sh lookForAll].
	PirateShow writeToFile .
	Transcript show: '-------------'; cr.
	self changed: #list] fork.! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/18/2013 07:02'!
newEpisodes
	| m ep |
	m := PirateNewMorph new.
	m model: model.
	m openInWorld.! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 12/10/2013 04:12'!
pairing
	PiratePairingEditor new open.! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 5/31/2014 23:27'!
play
	| ep |
	listIndex3 > 0
		ifTrue: [
			ep := model3 episodes at: listIndex3.
			ep isDownloaded ifTrue: [
				ep play.
				(self confirm: 'Did you see the entire show?') ifTrue: [
					[ep viewed.				
					self changed: #list1.
					self changed: #list3 ] forkAt: Processor userBackgroundPriority .		
				].
"				(self confirm: 'Subtitles OK?') ifTrue: ["
"					ep viewed."	"]."
			].
		]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 1/28/2013 20:48'!
refresh
	Cursor wait showWhile: [
		PirateTorrent updateStatuses .
		self changed: #list.
		self changed: #list3 .
		"PirateTorrent cleanUpSeedingDoneOnce."
		Transcript show: '-------------'; cr.
	].
	! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 9/3/2012 07:05'!
removeEpisode
	| rc |
	listIndex > 0 ifTrue: [
			(self confirm: 'Vill du verkligen ta bort avsnittet?') ifTrue: [
				self changed: #list3.
				self changed: #listIndex3.
				]
			].! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 1/31/2014 23:38'!
removeSeen
	[
		self refresh.
		PirateTorrent cleanUpSeedingDoneOnce.
		Transcript show: '-------------'; cr.
	] forkAt: Processor userBackgroundPriority .		
	! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 11/17/2013 23:59'!
seenEpisode
	| ep |
	listIndex3 > 0
		ifTrue: [
			ep := model3 episodes at: listIndex3.
			ep isViewed 
				ifTrue: [ep unViewed ]
				ifFalse: [ep viewed].
			self changed: #list1.
			self changed: #list3			
		]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/4/2015 07:20'!
test
	| ep magnet t |
	listIndex3 = 0
		ifTrue: [ ^ self ].
	ep := model3 episodes at: listIndex3.
	magnet := UIManager default request: 'Magnet'.
	magnet = ''
		ifTrue: [ ^ self ].
	t := PirateTorrent magnet: magnet.
	ep
		torrent: t;
		download! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/15/2013 06:59'!
testDeleteSubtitles
	| m ep |
	listIndex3 > 0
		ifTrue: [
			ep := model3 episodes at: listIndex3.
			ep deleteSubtitles.
		]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/18/2013 06:58'!
viewables
	| m ep |
	m := PirateViewableMorph new.
	m model: model.
	m openInWorld.! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 9/3/2012 06:58'!
writeToFile
	Cursor wait showWhile: [PirateShow writeToFile].
	^self ! !

BlocketRootMorph subclass: #PirateMovieMorph
	instanceVariableNames: 'shows listIndex model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

BlocketRootMorph subclass: #PirateNewMorph
	instanceVariableNames: 'shows listIndex model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:04'!
addControls
	| r lst btnPanel morph |
	self
		addMorphBack: (StringMorph contents: 'Title: ').

	lst := PluggableMultiColumnListMorph
				on: self
				list: #list
				selected: #listIndex
				changeSelected: #listIndex:.
		"		menu: #listMenu:."
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getEpisodeText:  .
	lst color: Color white.
	lst extent: 400 @ 500.
	self addMorphBack: lst.
	
	btnPanel := self newRow.
	btnPanel color: Color transparent;
		 borderWidth: 0;
		 layoutInset: 2;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	self addMorphBack: btnPanel.
	btnPanel
		addMorphBack: (self newButton: 'Refresh' do: #refresh).
"	btnPanel
		addMorphBack: (self newButton: 'Play' do: #play).
	btnPanel
		addMorphBack: (self newButton: 'Subtitles...' do: #subtitles).
"	"------------------------------------"
	r := AlignmentMorph newRow color: Color transparent;
				 borderWidth: 0;
				 layoutInset: 0.
	r wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	r
		addMorphBack: (self newButton: 'Close' do: #delete).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphFront: r! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 22:16'!
dblClick
	self open ! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:00'!
getEpisodeText: anEpisode

 ^{anEpisode season show name.
	anEpisode season id.
	anEpisode id. 
	(anEpisode hasSubtitle)ifTrue:['subs']ifFalse:[' - '].
	}.! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:00'!
icon
	^ nil! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:00'!
initialize
	super initialize.! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:01'!
list
	model
		ifNil: [^ nil].
	^ model! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:01'!
listIndex
	^ listIndex
		ifNil: [listIndex := 0]! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:01'!
listIndex: aSmallInteger 
	listIndex := aSmallInteger.
	self changed: #listIndex.
	! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:01'!
model:  allShows 
	shows := allShows.
	self refresh.
! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 22:15'!
open
	| m ep |
	listIndex > 0
		ifTrue: [m := PirateEpisodeMorph new.
			ep := model at: listIndex.
			m model: ep.
			m openInWorld.
			]! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:05'!
refresh
	| tmp |
	model := OrderedCollection new.
	tmp := shows collect: [:s|s newEpisode].
	model := tmp reject: [:i| i isNil].
	self changed: #list.
! !

BlocketRootMorph subclass: #PirateSubtitleMorph
	instanceVariableNames: 'model listEn listIndexEn listSwe listIndexSwe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateSubtitleMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/25/2015 07:32'!
addControls
	| r lst btnPanel |
	self addMorphBack: (StringMorph contents: 'Title: ').	"self
	addMorph: (PluggableTextMorph
	on: nil
	text: #getTitle
	accept: #setTitle)."
	lst := PluggableMultiColumnListMorph
		on: self
		list: #listEn
		selected: #listIndexEn
		changeSelected: #listIndexEn:
		menu: #listMenu:.
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getSubColumn:.
	lst color: Color white.
	lst extent: 500 @ 130.
	self addMorphBack: lst.
	lst := PluggableMultiColumnListMorph
		on: self
		list: #listSwe
		selected: #listIndexSwe
		changeSelected: #listIndexSwe:
		menu: #listMenu:.
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getSubColumn:.
	lst color: Color white.
	lst extent: 500 @ 130.
	self addMorphBack: lst.
	btnPanel := self newRow.
	btnPanel
		color: Color transparent;
		borderWidth: 0;
		layoutInset: 2;
		wrapCentering: #center;
		cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 5 @ 5.
	self addMorphBack: btnPanel.
	btnPanel addMorphBack: (self newButton: 'Refresh.' do: #getSubtitles).
	btnPanel addMorphBack: (self newButton: 'Download' do: #setSub).
	self addMorphBack: (self newButton: 'temp' do: #temp).	"------------------------------------"
	r := AlignmentMorph newRow
		color: Color transparent;
		borderWidth: 0;
		layoutInset: 0.
	r
		wrapCentering: #center;
		cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 5 @ 5.
	r addMorphBack: (self newButton: 'Close' do: #delete).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphFront: r! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/14/2012 20:58'!
dblClick
	self setSub.
	self delete.! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/2/2014 00:12'!
downloadSub: subDict
	| os |
	Cursor wait showWhile: [os := OpenSubClient current.
		os login.
		os downloadSubtitle: subDict fileName: (model videoFile fullVideoFilename ).
		os logout.]! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 6/25/2012 11:47'!
findCurrentSub
! !

!PirateSubtitleMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/12/2013 20:44'!
getSubColumn: sub
	^ {sub at: #MovieName.
		(sub at: #SeriesSeason) , '->',
		(sub at: #SeriesEpisode).
		sub at: #SubRating.
		sub at: #SubDownloadsCnt.
		(sub at: #SubHearingImpaired) = '1'
			ifTrue:['HI']
			ifFalse:['-'].
		sub at: #MatchedBy	
		}! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 11/25/2013 07:27'!
getSubtitles
	| |
	model
		ifNil: [^ self].
	Cursor wait showWhile: [
		listEn := model subtitles: 'eng'.	
		listEn := listEn .
		self changed: #listEn.
		listIndexEn := 0.

		listSwe := model subtitles: 'swe'.
		listSwe := listSwe .
		self changed: #listSwe.
		listIndexSwe := 0.
	].! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/11/2012 07:53'!
getSubtitlesOld
	| allSubs |
	model
		ifNil: [^ self].
	"["
	allSubs := model getSubtitles.self halt.
	listEn := allSubs
				reject: [:i | (i at: 1)
						includesSubstring: 'swesub'
						caseSensitive: false].
	self changed: #listEn.
	listIndexEn := 0.
	listSwe := allSubs
				select: [:i | (i at: 1)
						includesSubstring: 'swesub'
						caseSensitive: false].
	self changed: #listSwe.
	listIndexSwe := 0.
	WorldState
		addDeferredUIMessage: [self findCurrentSub
			"] fork"]! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/16/2012 21:33'!
listEn
	listEn ifNil: [^ nil].
	listEn isArray 
		ifTrue: [^ listEn]
		ifFalse: [^ nil].
		"collect: [:f | listEn
				collect: [:i | i at: f]]"! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 6/25/2012 11:35'!
listIndexEn
	^ listIndexEn
		ifNil: [listIndexEn := 0]! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/17/2012 07:44'!
listIndexEn: aSmallInteger 
	listIndexEn := aSmallInteger.
	self changed: #listIndexEn.
	listIndexSwe:=0.
	self changed: #listIndexSwe.! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 6/25/2012 11:35'!
listIndexSwe
	^ listIndexSwe
		ifNil: [listIndexSwe := 0]! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/17/2012 07:45'!
listIndexSwe: aSmallInteger 
	listIndexSwe:=aSmallInteger.
	self changed: #listIndexSwe.
	listIndexEn := 0.
	self changed: #listIndexEn.
! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/16/2012 21:38'!
listSwe
	listSwe
		ifNil: [^ nil].
	listSwe isArray
		ifTrue: [^listSwe]
		ifFalse: [^ nil].! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 6/25/2012 11:38'!
model: anEpisode 
	model := anEpisode.
	self getSubtitles! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 06:59'!
setSub
	| t |
	self listIndexEn > 0
		ifTrue: [t := listEn at: listIndexEn].
	self listIndexSwe > 0
		ifTrue: [t := listSwe at: listIndexSwe].
	t isNil
		ifFalse: [
			self downloadSub: t.
			model setSub: t]! !

!PirateSubtitleMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 9/1/2012 09:58'!
temp
	| out err desc args proc |
	self halt.
	out := FileStream forceNewFileNamed: '/tmp/deleteMe.out'.
	err := FileStream forceNewFileNamed: '/tmp/deleteMe.err'.
	desc := Array
				with: nil
				with: out
				with: err.
	args := Array
				with: '--fullscreen'
				with: '/media/cm1store/Torrent/Girls.S01E01.HDTV.x264-ASAP.mp4'.
	proc := UnixProcess
				forkJob: '/usr/bin/vlc'
				arguments: args
				environment: nil
				descriptors: desc.
	proc ifNil: [UnixProcess noAccessorAvailable].
	[proc isComplete] whileFalse:
		[(Delay forMilliseconds: 200) wait.].
	out close.
	err close.
	self inform: 'klart!!!!'.
	^ proc
"	^ self"! !

BlocketRootMorph subclass: #PirateViewableMorph
	instanceVariableNames: 'shows listIndex model showsStarted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/30/2013 01:15'!
addControls
	| r lst btnPanel morph started |
	started := CheckboxMorph on: self selected: #showsStarted changeSelected: #showStarted.
	started label: 'Show only started'.
	started height: 20.
	self addMorphBack: started.
	lst := PluggableMultiColumnListMorph
				on: self
				list: #list
				selected: #listIndex
				changeSelected: #listIndex:.
		"		menu: #listMenu:."
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getEpisodeText:  .
	lst color: Color white.
	lst extent: 400 @ 400.
	self addMorphBack: lst.
	
	btnPanel := self newRow.
	btnPanel color: Color transparent;
		 borderWidth: 0;
		 layoutInset: 2;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	self addMorphBack: btnPanel.
	btnPanel
		addMorphBack: (self newButton: 'Refresh' do: #refresh).
	btnPanel
		addMorphBack: (self newButton: 'Play' do: #play).
	btnPanel
		addMorphBack: (self newButton: 'Subtitles...' do: #subtitles).
	btnPanel
		addMorphBack: (self newButton: 'Top Sub' do: #topSubtitles).
	"------------------------------------"
	r := AlignmentMorph newRow color: Color transparent;
				 borderWidth: 0;
				 layoutInset: 0.
	r wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	r
		addMorphBack: (self newButton: 'Close' do: #delete).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphFront: r! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/13/2013 19:57'!
dblClick
	"	self inform: 'dubbelclickade'."
	listIndex > 0
		ifTrue: [ self play ]! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/21/2012 07:04'!
getEpisodeText: anEpisode

 ^{anEpisode season show name.
	anEpisode season id.
	anEpisode id. 
	(anEpisode hasSubtitle)ifTrue:['subs']ifFalse:[' - '].
	}.! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/2/2012 23:18'!
icon
	^ nil! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/9/2012 22:48'!
initialize
	super initialize.! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/16/2012 23:48'!
list
	model
		ifNil: [^ nil].
	^ model! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/9/2012 22:51'!
listIndex
	^ listIndex
		ifNil: [listIndex := 0]! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/9/2012 22:51'!
listIndex: aSmallInteger 
	listIndex := aSmallInteger.
	self changed: #listIndex.
	! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/13/2013 16:57'!
model:  allShows 
	shows := allShows.
	self refresh.
! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/30/2013 01:55'!
play
	| ep |
	(self listIndex = 0) ifTrue: [^self].
	ep := model at: listIndex.
	ep isDownloaded
		ifTrue: [ 
			ep play.
			(self confirm: 'Did you see the entire show?')
				ifTrue: [ 
					[ 
"					(self confirm: 'Subtitles OK?')
				ifTrue: [  ].
"					ep viewed.
					self refresh.
					self changed: #list ] forkAt: Processor userBackgroundPriority ].
			 ]! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/3/2013 06:38'!
refresh
	| tmp |
	model := OrderedCollection new.
	tmp := shows collect: [:s|s nextEpisode].
	tmp := tmp reject: [:i| i isNil].
	self showsStarted ifTrue: [
		tmp := tmp reject: [:i|
			(i id = '01') and: [i season id = '01']
			]
		].
	model:= tmp.
	self changed: #list.
 ! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/3/2013 06:33'!
showStarted
	showsStarted :=self showsStarted not.
	self refresh.! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/4/2013 06:27'!
showsStarted
	showsStarted
		ifNil: [showsStarted := true].
	^ showsStarted! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/30/2013 01:55'!
subtitles
	| ep m |
		(self listIndex = 0) ifTrue: [^self].

	ep := model at: listIndex.

	ep isDownloaded
		ifTrue: [ 
			m:=PirateSubtitleMorph new.
			m model: ( ep).
			m openInWorld.
			self changed: #list			 
		]! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/12/2014 09:51'!
topSubtitles
	| ep |
	self listIndex = 0
		ifTrue: [ ^ self ].
	ep := model at: listIndex.
	ep isDownloaded
		ifTrue: [ 
			ep topSubtitles.
			self changed: #list ]! !

WAComponent subclass: #PirateWebMobile
	instanceVariableNames: 'model showsNotStarted showsStarted listId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Web'!

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/19/2013 07:50'!
getList
	| allShows tmp |
	allShows := PirateShow shows.
	model := OrderedCollection new.
	tmp := allShows collect: [:s|s nextEpisode].
	tmp := tmp reject: [:i| i isNil].
	self showsStarted ifTrue: [
		tmp := tmp reject: [:i|
			(i id = '01') and: [i season id = '01']
			]
		].
	model:= tmp.! !

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/19/2013 07:56'!
initialize
	super initialize .
	self refresh.! !

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/19/2013 07:51'!
refresh
	self getList .! !

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/18/2013 08:42'!
renderContentOn: html
	html div jqmHeader ;
		jqmFixedPosition;
		with: [
			html heading: 'TV-program-program' .
			html anchor jqmIcon: 'refresh';
				with: 'Refresh';
				callback: [self refresh] ].
	html div jqmContent ;
		with: [
			"html paragraph: 'hello'."
			self renderTypeSwitchOn: html.
			html paragraph.
			self renderListOn: html.
		].
	html div jqmFooter ;
		jqmFixedPosition;
		with: [html heading level4; 
				with: 'hello'].! !

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/19/2013 08:15'!
renderListOn: html
	listId := html nextId.
"	self halt.
"	html unorderedList 
		jqmListView ;
		id: listId;
		with: [
			model do: [ :s |
				html listItem: [
					html anchor
						callback: [];
						with: s season show name , ' - ' ,  s season id.
					]
				]
			]! !

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/19/2013 07:59'!
renderTypeSwitchOn: html
	html form
	with: [
"	self renderFormElementsOn: html element: ["
		html fieldSet
			jqmControlGroup;
			jqmHorizontal;
			with: [
				html label 
					for: html nextId;
					with: 'New'.
				html checkbox
					value: self showsNotStarted;
					id: html lastId.
				html label 
					for: html nextId;
					with: 'Started'.
				html checkbox
					value: self showsStarted;
					id: html lastId.
				]
		]! !

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/19/2013 08:00'!
showsNotStarted
	^ showsNotStarted ifNil: [showsNotStarted:=false]! !

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/19/2013 08:02'!
showsNotStarted: aBoolean
	showsNotStarted := aBoolean! !

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/19/2013 08:01'!
showsStarted
	^ showsStarted ifNil: [showsStarted:=true]! !

!PirateWebMobile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 7/19/2013 08:02'!
showsStarted: aBoolean
	showsStarted := aBoolean! !

Object subclass: #Config
	instanceVariableNames: 'host port torrentFolder vlcFolder'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!Config class methodsFor: 'as yet unclassified' stamp: 'VictorAssmundsson 9/22/2014 23:11'!
current
	Current isNil
		ifTrue: [Current := self new]. 
	^ Current! !

!Config class methodsFor: 'as yet unclassified' stamp: 'VictorAssmundsson 9/22/2014 23:11'!
new
	^super new initialize! !

!Config methodsFor: 'as yet unclassified' stamp: 'VictorAssmundsson 9/22/2014 23:12'!
host
	^host! !

!Config methodsFor: 'as yet unclassified' stamp: 'VictorAssmundsson 9/22/2014 23:16'!
initialize 
	host := 'localhost'.
	port := 9091.
	vlcFolder := 'C:\Program Files (x86)\VideoLAN\VLC\vlc.exe'.
	torrentFolder := 'F:\Zetum\Downloads\Torrent\tv_program\'.! !

!Config methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2015 21:37'!
initializeFromFile
	| stream if |
	stream := FileStream readOnlyFileNamed: 'TVconfig.ini'.
	if := INIFile readFrom: stream.
	host := if section: #Global at: #Host ifAbsent: [ 'localhost' ].
	port := if section: #Global at: #Port ifAbsent: [ 'l9091' ].
	vlcFolder := if section: #Global at: #VlcFolder ifAbsent: [ 'C:\Program Files (x86)\VideoLAN\VLC\vlc.exe' ].
	torrentFolder := if section: #Global at: #TorrentFolder ifAbsent: [ 'F:\Zetum\Downloads\Torrent\tv_program\' ].
	Transcript crShow: self name , ' initializedFromFile' .
! !

!Config methodsFor: 'as yet unclassified' stamp: 'VictorAssmundsson 9/22/2014 23:17'!
port
	^port! !

!Config methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/15/2015 12:07'!
printOn: aStream
	aStream
		nextPutAll:
			'a TV-config (' , 'host:' , host , ' port:' , port , ' torrentFolder:' , torrentFolder , ' vlcFolder:' , vlcFolder
				, ') '! !

!Config methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/17/2015 07:10'!
torrentFolder
	torrentFolder isNil 
		ifTrue: [self initialize].
	^ torrentFolder.! !

!Config methodsFor: 'as yet unclassified' stamp: 'VictorAssmundsson 9/22/2014 23:17'!
vlcFolder
	^vlcFolder! !

Object subclass: #OpenSubClient
	instanceVariableNames: 'token proxy'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!OpenSubClient class methodsFor: 'as yet unclassified' stamp: 'CAs 7/16/2012 20:12'!
current
	^ Current ifNil: [Current := self new]! !

!OpenSubClient class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 8/24/2014 18:10'!
reset
	^ Current := nil! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/28/2013 13:08'!
compare: a and: b
	((a at: 'SubHearingImpaired') < (b at: 'SubHearingImpaired')) ifTrue: [^ true].
	((a at: 'SubHearingImpaired') > (b at: 'SubHearingImpaired')) ifTrue: [^ false].
	((a at: 'SubRating')asNumber > (b at: 'SubRating')asNumber) ifTrue: [^ true].
	((a at: 'SubRating')asNumber < (b at: 'SubRating')asNumber) ifTrue: [^ false].
	((a at: 'SubDownloadsCnt')asInteger > (b at: 'SubDownloadsCnt')asInteger) ifTrue: [^ true].
	((a at: 'SubDownloadsCnt')asInteger < (b at: 'SubDownloadsCnt')asInteger) ifTrue: [^ false].
	^ true! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/15/2015 20:01'!
downloadSubtitle: subDict fileName: aVideoFileName
	"struct LogIn(string $username, string $password, string $language, string $useragent)"

	| r a data base64 zip text zipStream fs srtName |
	a := {token.
	{(subDict at: #IDSubtitleFile)}}.
	r := self proxy invokeMethod: 'DownloadSubtitles' withArgs: a.
	(r at: 'status') = '200 OK'
		ifFalse: [ ^ nil ].
	(data := r at: #data) isEmpty
		ifTrue: [ ^ nil ].
	base64 := data first at: #data.
	zip := Base64MimeConverter mimeDecodeToBytes: base64 readStream.
	zipStream := GZipReadStream on: zip.
	text := zipStream contents.
	srtName := self srtFromVideo: aVideoFileName.	"	fs:=FileDirectory default forceNewFileNamed: srtName."
	fs := FileSystem disk openFileStream: srtName writable: true.
	fs nextPutAll: text.
	fs close.
	^ self! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'CAs 7/22/2012 10:25'!
login
"struct LogIn(string $username, string $password, string $language, string $useragent)"
	| d r a |
	a := { 'iwantmytv'. 'gotchas'. 'en'. 'IwantMyTV v0.1' }.
 
	r := self proxy invokeMethod: 'LogIn' withArgs: a.
"struct(
    (string) [token],
    (string) [status],
    (double) [seconds]
  )"
	token := r at: 'token'.
	^ self! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'CAs 7/16/2012 21:51'!
logout
"struct LogIn(string $username, string $password, string $language, string $useragent)"
	| d r a |
	a := #().
 
	r := self proxy invokeMethod: 'Logout' withArgs: a.
	^ self! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 8/24/2014 18:09'!
proxy
	| url |
	proxy isNil ifTrue: [
		url := Url absoluteFromText: 'http://api.opensubtitles.org/xml-rpc'.
		proxy := XMLRPCProxy new url: url. 
	].
	^ proxy! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/1/2014 23:48'!
searchSubtitles: aDictionary
"struct SearchSubtitles(string $token, array(struct('sublanguageid' => string $sublanguageid, 'moviehash' => string $moviehash, 'moviebytesize' => int $moviesize, 'imdbid' => string $imdbid ), struct(...)))"
	| r a data |
	
	a := { token.  {aDictionary} }.
 
	r := self proxy invokeMethod: 'SearchSubtitles' withArgs: a.
	data := r at: 'data'.
	^ data! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/1/2013 10:01'!
searchSubtitlesByname: array lang: lang
"struct SearchSubtitles(string $token, array(struct('sublanguageid' => string $sublanguageid, 'moviehash' => string $moviehash, 'moviebytesize' => int $moviesize, 'imdbid' => string $imdbid ), struct(...)))"
	| d data |
	self obsolete .
	self halt.
	d := Dictionary new.
	d at: 'query' put: (array at: 1).
	d at: 'season' put: (array at: 2).
	d at: 'episode' put: (array at: 3).
	d at: 'sublanguageid' put: lang.
	
	data := self searchSubtitles: d.
	(data isKindOf: Boolean) ifTrue: [^#()].
	data := self sortSubtitles: data.
	^ self! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/1/2013 10:01'!
searchSubtitlesByname: name season: aSeason episode: anEpisode lang: lang
	| d data |
	d := Dictionary new.
	d at: 'query' put: name.
	d at: 'season' put: aSeason .
	d at: 'episode' put: anEpisode .
	d at: 'sublanguageid' put: lang.

	data := self searchSubtitles: d.
	(data isKindOf: Boolean) ifTrue: [^#()].
	data := self sortSubtitles: data.
	^ data! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'CAs 7/16/2012 21:03'!
searchSubtitlesForHash: aHash size: fileSize
	^ self searchSubtitlesForHash: aHash size: fileSize lang: 'eng'! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/1/2013 10:02'!
searchSubtitlesForHash: aHash size: fileSize lang: lang
	| d data |
	aHash ifNil: [^nil].
	d := Dictionary new.
	d at: 'sublanguageid' put: lang.
	d at: 'moviehash' put: aHash.
	d at: 'moviebytesize' put: fileSize printString.
	
	data := self searchSubtitles: d.
	(data isKindOf: Boolean) ifTrue: [^#()].
	data := self sortSubtitles: data.
	^ data! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/1/2014 23:49'!
searchSubtitlesForHash: aHash size: fileSize season: aSeason episode: anEpisode lang: lang
	| data |
	data := self searchSubtitlesForHash: aHash size: fileSize lang: lang.
	data := data select: [:i| ((i at: #SeriesEpisode) asInteger = anEpisode) and: [(i at: #SeriesSeason) asInteger = aSeason ]].
	^ data! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/22/2013 01:02'!
sortSubtitles: aSubDict
	| tmp |
	tmp := aSubDict sort: [ :a :b | self compare: a and: b ].
	^ tmp .
	! !

!OpenSubClient methodsFor: 'as yet unclassified' stamp: 'CAs 7/21/2012 20:13'!
srtFromVideo: aVideoFileName
	| lastDot base |
	lastDot := aVideoFileName findLastOccurrenceOfString: '.' startingAt: 1. 
	base := aVideoFileName copyFrom: 1 to: lastDot-1. 
	^base , '.srt'! !

Object subclass: #PiratePairingEditor
	instanceVariableNames: 'videos files torrent show selectionIndexFiles selectionIndexVideos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:14'!
canConnect
	^(selectionIndexVideos > 0) and: [ selectionIndexFiles > 0 ]! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:45'!
connectButtonClick
	self selectedVideo videoFile: (self selectedFile ).
	self selectedFile video: (self selectedVideo ).
	
	self changed: #listVideos.
	self changed: #listFiles.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/10/2013 23:45'!
getFileName: aVideoFile 	
	^aVideoFile videoFilename.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/17/2013 07:09'!
getVideoName: anEpisode
	^anEpisode fullId.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:39'!
initialize
	super initialize.
	self selectionIndexFiles: 0.
	self selectionIndexVideos: 0! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:54'!
inspectVideo
	self selectedVideo explore.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:19'!
listFiles
	files := self torrent videoFiles.
	^ files select: [ :vf | vf video isNil ].
! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:43'!
listVideos
	| seasons available |
	seasons := self show seasons.
	videos := OrderedCollection new.
	seasons do: [ :s | videos addAll: s episodes ].
	available := videos select: [ :e | e videoFile isNil ].
	^ available! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:03'!
open
	| builder content |
	builder := UITheme builder.
	content := builder
		newColumn:
			{((builder
				newRow:
					{((builder
						newListFor: self
						list: #listVideos
						selected: #selectionIndexVideos
						changeSelected: #selectionIndexVideos:
						help: 'This is a list')
						minWidth: 190;
						wrapSelector: #getVideoName:).
					((builder
						newListFor: self
						list: #listFiles
						selected: #selectionIndexFiles
						changeSelected: #selectionIndexFiles:
						help: 'This is a list')
						minWidth: 190;
						wrapSelector: #getFileName:)}) vResizing: #spaceFill).	"			(builder
				newListFor: self
				list: #contacts
				selected: #contactSelectedIndex
				changeSelected: #contactSelectedIndex:
				help: 'contacts')."
			(builder
				newRow:
					{(builder
						newButtonFor: self
						action: #connectButtonClick
						getEnabled: #canConnect
						label: 'Connect'
						help: 'Create a new contact').
					(builder
						newButtonFor: self
						action: #removeButtonClick
						getEnabled: nil
						label: 'Remove'
						help: 'Remove selected contact').
					(builder
						newButtonFor: self
						action: #inspectVideo
						getEnabled: nil
						label: 'Inspect Video'
						help: 'Remove selected contact').
					(builder
						newButtonFor: self
						action: #inspectFile
						getEnabled: nil
						label: 'Inspect File'
						help: 'Remove selected contact')	"					(builder
						newButtonFor: self
						action: #editButtonClick
						getEnabled: #hasSelectedContact
						label: 'Edit'
						help: 'Edit selected contact')"})}.
	(content openInWindowLabeled: 'Contacts') extent: 600 @ 500! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:20'!
selectedFile
	"Answer the currently selected item or nil if none."

	^self selectionIndexFiles = 0
		ifTrue: [nil]
		ifFalse: [self listFiles at: self selectionIndexFiles]! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:53'!
selectedVideo
	"Answer the currently selected item or nil if none."

	^self selectionIndexVideos  = 0
		ifTrue: [nil]
		ifFalse: [self listVideos at: self selectionIndexVideos]! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:46'!
selectionIndexFiles
	"Answer the value of selectionIndex"

	^ selectionIndexFiles! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:13'!
selectionIndexFiles: anObject
	"Set the value of selectionIndex"

	selectionIndexFiles := anObject.
	self changed: #selectionIndexFiles.
	self changed: #canConnect.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:46'!
selectionIndexVideos
	"Answer the value of selectionIndex"

	^ selectionIndexVideos! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:13'!
selectionIndexVideos: anObject
	"Set the value of selectionIndex"

	selectionIndexVideos := anObject.
	self changed: #selectionIndexVideos.
	self changed: #canConnect.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/17/2013 07:00'!
show
	^PirateShow at: 'Coupling'! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/17/2013 06:53'!
torrent
	| t |
	t:= PirateTorrent at: '959b3ac4196f2eaa3102abb52bc3d81742e74734'.
	^t! !

Object subclass: #PostgresObject
	instanceVariableNames: 'uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate'!

PostgresObject subclass: #PirateApp
	instanceVariableNames: ''
	classVariableNames: 'TheMaid'
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!PirateApp class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/13/2014 09:47'!
initialize 
	super initialize .
	self initializeStartupShutdown.! !

!PirateApp class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/13/2014 09:48'!
initializeStartupShutdown
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	"Remove startup from PirateShow where it used top be"
	Smalltalk removeFromStartUpList: PirateShow .
	Smalltalk removeFromShutDownList: PirateShow .
! !

!PirateApp class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/1/2014 00:39'!
shutDown: quitting
	Transcript crShow: self name , ' shutDown: ' , quitting printString.
	quitting
		ifTrue: [ 
			TheMaid isNil
				ifFalse: [ TheMaid terminate ] ]! !

!PirateApp class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/12/2015 07:37'!
startUp: resuming
	Transcript crShow: self name , ' startUp: ' , resuming printString.
	resuming
		ifTrue: [ Config current initializeFromFile ]! !

PostgresObject subclass: #PirateSeason
	instanceVariableNames: 'show episodes id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 4/10/2012 08:14'!
addEpisode
	| newEpisode |
	newEpisode := PirateEpisode new.
	newEpisode id: (self maxEpisode + 1) asTwoCharacterString.
	self addEpisode: newEpisode.
	^newEpisode! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:22'!
addEpisode: anEpisode
	episodes add: anEpisode.
	anEpisode season: self.! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 6/30/2012 12:27'!
addEpisodeNo: anInteger
	| newEpisode |
	newEpisode := PirateEpisode new.
	newEpisode id: anInteger asTwoCharacterString.
	self addEpisode: newEpisode.
	^newEpisode! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 7/21/2012 11:45'!
delete
	episodes do: [:e| e delete].! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:22'!
episodes 
	^episodes ! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/16/2012 07:16'!
found
	^ episodes
		select: [ :i  | i found]! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 11:17'!
fullId
	^ show name , ' S' , self id! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 11:00'!
id
	id isNil
		ifTrue: [^ 'undefined'].
	^ id! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 11:01'!
id: aString
	id := aString! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:12'!
initialize
	super initialize.
	episodes := OrderedCollection new.! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/15/2015 20:51'!
lookForAll
	^ episodes
		do: [:i | i lookForItIfNotFound]! !

!PirateSeason methodsFor: 'accessing' stamp: 'CAs 3/31/2012 10:38'!
maxEpisode
	"(Array with: '11' asInteger with: '12' asInteger )max ."
	| ids |
	episodes isEmptyOrNil ifTrue: [^0]. .
	ids := episodes
				collect: [:e | e id asInteger].
	^ ids max! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/8/2012 22:15'!
name
	^show name! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 4/11/2012 08:13'!
newFound
	^ episodes
		select: [:i | i newFound]! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:11'!
nextEpisode
	episodes isEmptyOrNil ifTrue: [^'E*'].

^'E*'! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 9/14/2012 21:03'!
notSeen
	^ episodes
		select: [:i | i isViewable]! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 11:08'!
printOn: aStream 
	aStream
		nextPutAll:  'S' , self id! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/5/2013 06:58'!
resetUplinks: up
	show := up.
	^ episodes
		do: [:i | i resetUplinks: self]! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:20'!
show
	^show! !

!PirateSeason methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:20'!
show: aShow
	^show := aShow! !

PostgresObject subclass: #PirateShow
	instanceVariableNames: 'name seasons currentSeason archived tags'
	classVariableNames: 'Shows'
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!PirateShow class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/17/2013 07:00'!
at: aTitle
	^self shows detect: [ :s | s name = aTitle ]! !

!PirateShow class methodsFor: 'files' stamp: 'ChristerAssmundsson 2/12/2015 07:22'!
fileName
	| folder fileName |
	"OSPlatform isUnix ifTrue: [ folder := '/media/cm1store/' ].
	OSPlatform isWin32 ifTrue: [ folder := 'O:\' ]."
	folder := Config current torrentFolder.
	fileName := folder, 	'TVshows'.
	^fileName! !

!PirateShow class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/11/2014 13:59'!
initialize 
	super initialize .
	self initializeStartupShutdown.! !

!PirateShow class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/13/2014 09:49'!
initializeStartupShutdown
"	Not used in startup anymore. moved to new class PirateApp 
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self."
! !

!PirateShow class methodsFor: 'as yet unclassified' stamp: 'CAs 2/5/2012 09:56'!
new
	| n |
	n := super new.
	self shows add: n.
	^n.! !

!PirateShow class methodsFor: 'temporary' stamp: 'ChristerAssmundsson 9/3/2012 06:52'!
reSort
	self shows reSort.
	^self! !

!PirateShow class methodsFor: 'files' stamp: 'ChristerAssmundsson 5/20/2014 18:44'!
readFromFile
	Shows := FLMaterializer materializeFromFileNamed: (self fileName,'.fuel').
	Transcript show: 'File read'; cr.
! !

!PirateShow class methodsFor: 'files' stamp: 'ChristerAssmundsson 5/20/2014 19:43'!
readFromFileSTON
	"	Shows := FLMaterializer materializeFromFileNamed: self fileName."

	(self fileName , '.ston') asFileReference
		readStreamDo: [ :stream | Shows := STON fromStream: stream ].
	Transcript
		show: 'File read from STON';
		cr! !

!PirateShow class methodsFor: 'as yet unclassified' stamp: 'CAs 7/21/2012 11:43'!
removeShow: aShow
	Shows isNil ifFalse: [
		aShow delete.
		Shows remove: aShow].
	^self.! !

!PirateShow class methodsFor: 'as yet unclassified' stamp: 'CAs 2/5/2012 10:10'!
reset
	Shows := nil.! !

!PirateShow class methodsFor: 'temporary' stamp: 'ChristerAssmundsson 1/14/2013 23:00'!
resetEpisodeStatus
	|  myShows |
	myShows := self shows.
	myShows do: [ 
		:sh | sh seasons do: [
			:season | season episodes do: [
				:episode | episode resetFileAndStatus.
				]
			] 
		]! !

!PirateShow class methodsFor: 'temporary' stamp: 'ChristerAssmundsson 2/5/2013 06:55'!
resetUplinks
	|  myShows |
	myShows := self shows.
	myShows do: [ 	:sh | sh resetUplinks]! !

!PirateShow class methodsFor: 'as yet unclassified' stamp: 'CAs 7/9/2012 03:27'!
shows
	Shows isNil ifTrue: [Shows := SortedCollection new].
	^Shows! !

!PirateShow class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/13/2014 09:52'!
shutDown: quitting
	self deprecated: 'Moved to PirateApp'! !

!PirateShow class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/13/2014 09:52'!
startUp: resuming
	self deprecated: 'Moved to PirateApp'! !

!PirateShow class methodsFor: 'files' stamp: 'ChristerAssmundsson 5/20/2014 18:44'!
writeToFile
	FLSerializer serialize: self shows toFileNamed: self fileName,'.fuel'.
	Transcript show: 'File written'; cr.
	GrowlMorph openWithLabel: 'File written' contents: ''.! !

!PirateShow class methodsFor: 'files' stamp: 'ChristerAssmundsson 6/23/2013 15:27'!
writeToFileBG
	[self writeToFile ] forkAt: Processor userBackgroundPriority .
! !

!PirateShow class methodsFor: 'files' stamp: 'ChristerAssmundsson 5/20/2014 19:35'!
writeToFileSTON
	"FLSerializer serialize: self shows toFileNamed: self fileName."
	(self fileName , '.ston') asFileReference writeStreamDo: 
		[ :stream | STON put: self shows onStream: stream ].
	Transcript
		show: 'File written to STON';
		cr.
	GrowlMorph openWithLabel: 'File written' contents: 'to STON'! !

!PirateShow methodsFor: 'comparing' stamp: 'ChristerAssmundsson 9/3/2012 06:55'!
<= aPirateShow 
	^(self name) caseInsensitiveLessOrEqual: (aPirateShow name).! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'CAs 5/25/2012 07:11'!
addSeason
	| newSeason |
	newSeason := PirateSeason new.
	newSeason id: (self maxSeason + 1) asTwoCharacterString.
	self addSeason: newSeason.
	^ newSeason! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:21'!
addSeason: aSeason 
	seasons add: aSeason.
	aSeason show: self! !

!PirateShow methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/2/2014 10:39'!
addTag: aString
	self tags addIfNotPresent: aString ! !

!PirateShow methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/31/2014 23:39'!
archived
	^ archived ifNil: [ archived := false ]! !

!PirateShow methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/31/2014 23:33'!
archived: aBool
	archived:= aBool .! !

!PirateShow methodsFor: 'accessing' stamp: 'CAs 3/3/2012 09:23'!
currentSeason
	^currentSeason! !

!PirateShow methodsFor: 'accessing' stamp: 'CAs 3/3/2012 09:23'!
currentSeason: aSeason
	currentSeason := aSeason! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'CAs 7/21/2012 11:44'!
delete
	seasons do: [:s| s delete].! !

!PirateShow methodsFor: 'initialize-release' stamp: 'CAs 3/3/2012 09:12'!
initialize
	super initialize.
	seasons := OrderedCollection new.! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/15/2015 20:50'!
lookForAll
	^ seasons
		do: [:i | i lookForAll]! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'CAs 5/25/2012 07:10'!
maxSeason
	"(Array with: '11' asInteger with: '12' asInteger )max ."
	| ids |
	seasons isEmptyOrNil
		ifTrue: [^ 0].
	ids := seasons
				collect: [:e | e id asInteger].
	^ ids max! !

!PirateShow methodsFor: 'accessing' stamp: 'CAs 2/5/2012 09:57'!
name
	name isNil ifTrue: [^'undefined'].
	^name! !

!PirateShow methodsFor: 'accessing' stamp: 'ChristerAssmundsson 9/3/2012 06:52'!
name: aByteString 
	name := aByteString.
	self class reSort.! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:06'!
newEpisode
	| model |
	model := OrderedCollection new.
	seasons 
		do: [:season| model addAll: (season episodes select: [:e| e newFound] )].
	model isEmpty 
		ifTrue: [^ nil ]
		ifFalse: [^ model first ].
	! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'CAs 4/18/2012 21:53'!
newEpisodeCount
	| sum |
	sum := 0.
	seasons
		do: [:s | sum:=sum+(s newFound size)
				].
	^ sum! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'CAs 4/11/2012 08:13'!
newFound
	^ seasons
		collect: [:i | i newFound]! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/31/2012 00:01'!
nextEpisode
	| model |
	model := OrderedCollection new.
	seasons 
		do: [:season| model addAll: (season episodes select: [:e| e isViewable] )].
	model isEmpty 
		ifTrue: [^ nil ]
		ifFalse: [^ model first ].
	! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 9/3/2012 07:09'!
notSeenCount
	| sum |
	sum := 0.
	seasons
		do: [:s | sum:=sum+(s notSeen size)
				].
	^ sum! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 11:09'!
printOn: aStream 
	aStream nextPutAll: (self name contractTo: 45)! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/5/2013 06:57'!
resetUplinks
	^ seasons
		do: [:i | i resetUplinks: self]! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:15'!
seasons
	^seasons! !

!PirateShow methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/2/2014 10:38'!
tags
	^ tags ifNil: [ tags := SortedCollection new ]! !

!PirateShow methodsFor: 'as yet unclassified' stamp: 'CAs 2/5/2012 10:01'!
tpbString
	"tpb = The Pirate Bay"
	^self name, '%20', (self nextEpisode)! !

PostgresObject subclass: #PirateTorrent
	instanceVariableNames: 'name magnet torrentHash seeders leechers status downloaded videoFiles folder'
	classVariableNames: 'AllTorrents DeathRow Reaper'
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/25/2015 07:41'!
AllTorrents 
	^AllTorrents ifNil: [AllTorrents= Set new].! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/8/2013 07:00'!
DeathRow
	^DeathRow ifNil: [DeathRow:= Set new].! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/25/2015 07:41'!
at: aHash
	| x |
	"	all := self allInstances."
	x := self AllTorrents detect: [ :i | i torrentHash = aHash ] ifNone: [ nil ].
	^ x! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/8/2013 07:27'!
cleanUpSeedingDone
	 | delay |
	delay := Delay forSeconds: 10.
	[[DeathRow isEmpty not]	
		whileTrue: [
			DeathRow copy do: [:i | i removeIfSeedComplete].
			delay wait].
		Reaper:=nil]! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/25/2014 21:35'!
cleanUpSeedingDoneOnce
	| done |
	done := self DeathRow select: [ :i | i isSeedingComplete ].
	done
		do: [ :i | 
			i removeTorrentAndData.
			DeathRow remove: i ifAbsent: [  ].
			Transcript
				show: 'deleting torrent:' , i name;
				cr.
			GrowlMorph openWithLabel: 'Torrent deleted' contents: i name ]! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/12/2015 07:23'!
folder
	| folder  |
	"OSPlatform isUnix ifTrue: [ folder := '/media/cm1store/Torrent/' ].
	OSPlatform isWin32 ifTrue: [ folder := 'O:\Torrent\' ]."
	folder := Config current torrentFolder.
	^folder! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'CAs 7/10/2012 20:58'!
from: anArrayOf4
	^ self new 
		name: anArrayOf4 first ;
		magnet: anArrayOf4 second;
		seeders: anArrayOf4 third;
		leechers: anArrayOf4 fourth;
		yourself.! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/25/2015 07:55'!
magnet: aMagnetString
	^ self new
		magnet: aMagnetString;
		yourself! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/4/2015 07:18'!
new
	| n |
	n := super new initialize.

	^ n! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/25/2015 07:46'!
setUpAllTorrents
	AllTorrents := Set new.
	self allInstances
		do: [ :i | 
			i isInServer
				ifTrue: [ AllTorrents add: i ] ]! !

!PirateTorrent class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2015 07:11'!
updateStatuses
	| allStats notInServer |
	allStats := TransmissionClient current getAll.
	allStats
		do: [ :s | 
			| t |
			t := self at: (s at: #hashString).
			t ifNotNilDo: [ :i | i status: (s at: #status) ] ].
	notInServer := self AllTorrents
		reject: [ :t | allStats anySatisfy: [ :each | (each at: #hashString) = t torrentHash ] ].
	notInServer do: [ :t | t status: -1 ]! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 2/15/2015 19:31'!
allVideosSeen
	videoFiles ifNil: [ ^true ].
	^ videoFiles allSatisfy: [ :f | f isSeen ].! !

!PirateTorrent methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/8/2014 23:42'!
checkStatus
	^self status: (TransmissionClient current getStatus: self torrentHash).
! !

!PirateTorrent methodsFor: 'converting' stamp: 'ChristerAssmundsson 2/15/2015 20:32'!
createVideoFile
	| f |
	self isSingleVideoFile
		ifFalse: [ self halt ].
	f := PirateVideoFile new.
	videoFiles := OrderedCollection with: f.
	f
		torrent: self;
		videoFilename: self videoFilenames first;
		folder: self folder.
	^ f! !

!PirateTorrent methodsFor: 'converting' stamp: 'ChristerAssmundsson 2/15/2015 20:32'!
createVideoFiles
	| f |
	videoFiles := OrderedCollection new.
	self videoFilenames
		do: [ :fname | 
			f := PirateVideoFile new.
			f
				torrent: self;
				videoFilename: fname;
				folder: self folder.
			videoFiles add: f ].
	^ videoFiles! !

!PirateTorrent methodsFor: 'accessing' stamp: 'CAs 7/21/2012 11:46'!
delete
	self removeTorrentAndData! !

!PirateTorrent methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/25/2014 21:34'!
doneWithThis
	self allVideosSeen
		ifFalse: [ ^ self ].
	(TransmissionClient current isTorrentInServer: self torrentHash)
		ifFalse: [ ^ self ].
	DeathRow isNil
		ifTrue: [ DeathRow := Set new ].
	DeathRow add: self.
	self startReaper! !

!PirateTorrent methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/4/2015 07:18'!
download
	TransmissionClient current addTorrent: self magnet.
	self class AllTorrents add: self! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/18/2015 07:44'!
folder
	| tmp |
	"^ folder
		ifNil: [" 
			tmp := TransmissionClient current getDir: self torrentHash.
			tmp isEmptyOrNil ifTrue:[^nil].
			tmp := tmp copyReplaceAll: self serverRoot with: self localFolder.
			tmp := tmp copyReplaceAll: self serverRoot2 with: self localFolder.
			tmp := tmp copyReplaceAll: '\' with: '/'.
			tmp := tmp copyReplaceAll: '//' with: '/'.
			(tmp endsWith: '/') ifFalse: [ tmp := tmp ,'/' ].
			OSPlatform isWin32 ifTrue: [ tmp := tmp copyReplaceAll: '/' with: '\'. ].
			folder := tmp.
			 "]"
		^folder! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 1/2/2014 01:22'!
isASample: aFilename size: anInt
	^ anInt < 50e6
! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 6/15/2014 23:02'!
isAVideoFile: aFilename
	| lastDot ext |
	lastDot := aFilename findLastOccurrenceOfString: '.' startingAt: 1. 
	ext := aFilename copyFrom: lastDot+1 to: aFilename size. 
	^ #( 'mp4' 'avi' 'mkv' 'wmv') includes: ext.
! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 5/25/2014 21:19'!
isDownloadComplete
	^downloaded ifNil: [ downloaded := false ].
	"(downloaded isNil or: [ downloaded not ])
		ifTrue: [ downloaded := TransmissionClient current isComplete: self torrentHash ]	.
	^downloaded."
	"^#(0 5 6) includes: self status"! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 9/14/2012 21:31'!
isDownloaded
"	downloaded ifNil: [downloaded := false].
	downloaded ifFalse: [
		downloaded := TransmissionClient current isComplete: self torrentHash.].
	^downloaded."
	^#(3 4 5 6) includes: self status! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 2/25/2015 07:37'!
isDownloading
	^ #(3 4) includes: self status! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 12/10/2013 03:11'!
isInServer
	^TransmissionClient current isHashInServer: self torrentHash .! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 5/30/2014 21:37'!
isSeedingComplete
	| times overtime |
	times := self videoFiles collect: [ :vf | vf viewTime ].
	times := times reject: [ :t | t isNil ].
	times isEmpty
		ifTrue: [ overtime := false ]
		ifFalse: [ overtime := times allSatisfy: [ :t | TimeStamp now - t > (Duration days: 45) ] ].
	^ overtime or: [ TransmissionClient current isSeedingComplete: self torrentHash ]! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 5/20/2014 20:26'!
isSingleVideoFile
	| files |
	files := self videoFilenames.
	(0= files size) ifTrue:[self halt].
	^ (1= files size)! !

!PirateTorrent methodsFor: 'accessing' stamp: 'CAs 7/10/2012 20:03'!
leechers: anInteger
	leechers := anInteger ! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 4/17/2014 17:18'!
localFolder
	^self class folder! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 12/10/2013 01:47'!
magnet
	^ magnet ifNil: [
		self torrentHash ifNil: [ self halt.].
		magnet := TransmissionClient current getMagnet: self torrentHash.]
! !

!PirateTorrent methodsFor: 'accessing' stamp: 'CAs 7/10/2012 20:02'!
magnet: aString 
	magnet := aString ! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 12/4/2013 23:08'!
name
	^name  ifNil: [name := TransmissionClient current getTitle: self torrentHash.]
! !

!PirateTorrent methodsFor: 'accessing' stamp: 'CAs 7/10/2012 20:02'!
name: aString
	name := aString ! !

!PirateTorrent methodsFor: 'printing' stamp: 'ChristerAssmundsson 12/10/2013 01:47'!
printOn: aStream 
	aStream nextPutAll:  self name! !

!PirateTorrent methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/10/2013 02:51'!
removeIfSeedComplete
self halt. "kolla alla videofiler frst"
	(self isSeedingComplete or: [ self isInServer not ])
	ifTrue: [
		self removeTorrentAndData.
		DeathRow remove: self ifAbsent: [].
		Transcript show:'deleting torrent:',name;cr] ! !

!PirateTorrent methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/16/2015 21:26'!
removeTorrentAndData
	| h |
	videoFiles := nil.
	h := self torrentHash.
	h isEmptyOrNil
		ifTrue: [ ^ self ].	
	TransmissionClient current removeTorrent: h.
	self class AllTorrents remove: self	 ifAbsent: [  ]! !

!PirateTorrent methodsFor: 'accessing' stamp: 'CAs 7/10/2012 20:03'!
seeders: anInteger
	seeders := anInteger ! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 3/18/2015 07:30'!
serverRoot
	^TransmissionClient current getDownloadDir! !

!PirateTorrent methodsFor: 'testing' stamp: 'ChristerAssmundsson 4/17/2014 17:48'!
serverRoot2
	^'/media/store2tb/Torrent'! !

!PirateTorrent methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/15/2015 11:43'!
startReaper
	| delay |
	Reaper isNil
		ifFalse: [ self stopReaper ].
	delay := Delay forSeconds: 10.
	Reaper := [ 
	[ DeathRow isEmpty not ]
		whileTrue: [ 
			self class cleanUpSeedingDoneOnce.
			delay wait ].
	Reaper := nil ] newProcess.
	Reaper
		priority: Processor userBackgroundPriority;
		name: #reaper;
		resume! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/2/2014 01:42'!
status
	^status ifNil: [-1]! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 2/15/2015 21:05'!
status: anInt
	status = anInt
		ifFalse: [ 
			status := anInt.
			downloaded := false.
			(#(5 6) includes: status)
				ifTrue: [ downloaded := true ].
			(#(0) includes: status)
				ifTrue: [ downloaded := (TransmissionClient current getTotalSize: self torrentHash) > 0 ].
			downloaded
				ifTrue: [ [ self videoHash ] forkAt: Processor userBackgroundPriority ] ].
	^ status! !

!PirateTorrent methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/10/2013 03:25'!
stopReaper
	Reaper isNil ifTrue: [^self].
	Reaper terminate.
	Reaper := nil.! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/18/2015 07:19'!
torrentHash
	| m start end tmp |
	torrentHash ifNotNil: [ ^torrentHash].
	m:=self magnet.
	m isEmptyOrNil ifTrue:[self halt. ^ ''].
	
	start := m findString: 'btih:'.
	(start = 0) ifTrue:[^ ''].
	end := m findString: '&' startingAt: start.
	tmp := m copyFrom: start+5 to: end-1.
	torrentHash := tmp asLowercase.
	^ torrentHash! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/18/2015 07:19'!
torrentHash: aHash
	torrentHash := aHash asLowercase.
! !

!PirateTorrent methodsFor: 'to_videofile' stamp: 'ChristerAssmundsson 1/1/2014 22:47'!
videoFilename
| files max fname |
self halt.
	files:= TransmissionClient current getFiles: self torrentHash.
	files isEmptyOrNil ifTrue: [^nil].
	max:=0.
	files do: [:f| (f at: #length)>max ifTrue: [fname:= f at: #name. max:=f at: #length]].
	^ self folder , fname.
! !

!PirateTorrent methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 20:25'!
videoFilenames
	| files fnames |
"	videoFiles ifNotNil: [ ^videoFiles  ]."
	files:= TransmissionClient current getFiles: self torrentHash.
	files isEmptyOrNil ifTrue: [^#()].
	files := files select: [:f| self isAVideoFile: (f at: 'name')].
	files := files reject: [ :f | self isASample: (f at: 'name') size: (f at: 'length')].
	fnames := files collect: [ :file| file at: 'name' ].
	^ fnames sort.! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 12/10/2013 23:38'!
videoFiles
	^videoFiles ifNil: [ self createVideoFiles ]! !

!PirateTorrent methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/1/2014 03:02'!
videoHash
	self videoFiles do: [ :vf | vf videoHash].! !

PostgresObject subclass: #PirateVideo
	instanceVariableNames: 'id torrent falseTorrents location subTitle viewed torrents videoFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate'!

PirateVideo subclass: #PirateEpisode
	instanceVariableNames: 'season'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!PirateEpisode methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 11:17'!
fullId
	^ season fullId , 'E',self id! !

!PirateEpisode methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/11/2013 06:50'!
getTorrents
	^ PirateRobot new getShow: self tpbString.! !

!PirateEpisode methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/2/2014 00:55'!
resetFileAndStatus
	Transcript show:'hej'.
	torrent := nil.
	falseTorrents := nil.
	subTitle := nil.
	viewed := false.
	Transcript show:' d!! '! !

!PirateEpisode methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/5/2013 06:59'!
resetUplinks: up
	season := up.! !

!PirateEpisode methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:20'!
season
	^season! !

!PirateEpisode methodsFor: 'as yet unclassified' stamp: 'CAs 3/3/2012 09:20'!
season: aSeason
	season := aSeason! !

!PirateEpisode methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/15/2015 19:32'!
subtitlesByHash: lang
	| os hash subs fileSize aSeason anEpisode |
	self videoFile ifNil:[^#()].

	hash := self videoFile videoHash.
	hash ifNil: [^#()]. 
	fileSize := self videoFile fileSize.
	aSeason := self season id asInteger  .
	anEpisode := self id asInteger  .
	os:= OpenSubClient current.
	os login.
	subs := os searchSubtitlesForHash: hash size: fileSize season: aSeason episode: anEpisode lang: lang.
"	os logout."
	^ subs! !

!PirateEpisode methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/1/2014 23:53'!
subtitlesByTitle: lang
	| os subs aName aSeason anEpisode |
	aName := self season name.
	aSeason := self season id asInteger  .
	anEpisode := self id asInteger  .

	os:= OpenSubClient current.
	os login.
	subs := os searchSubtitlesByname: aName season: aSeason episode: anEpisode lang: lang.
	os logout.
	^ subs! !

PirateVideo subclass: #PirateMovie
	instanceVariableNames: 'tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!PirateMovie methodsFor: 'printing' stamp: 'ChristerAssmundsson 2/24/2013 23:00'!
fullId
	^self id! !

!PirateMovie methodsFor: 'printing' stamp: 'ChristerAssmundsson 3/11/2013 06:50'!
getTorrents
	^ PirateRobot new getMovie: self tpbString.! !

!PirateMovie methodsFor: 'printing' stamp: 'ChristerAssmundsson 4/4/2013 06:30'!
initialize 
	super initialize .
	tags := Set new.! !

!PirateVideo class methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/20/2014 11:20'!
getAllSubtitles
	| needsSubs delay viewables |
	delay := Delay forSeconds: 5.	"self halt."
	viewables := self allSubInstances select: [ :ep | ep isViewable ].
	needsSubs := viewables select: [ :ep | ep hasSubtitle not ].
	needsSubs
		do: [ :ep | 
			ep topSubtitles.
			delay wait ]! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 1/2/2014 00:54'!
addFalseTorrent: aTorrentArray
	self falseTorrents add: aTorrentArray.
! !

!PirateVideo methodsFor: 'obsolete' stamp: 'ChristerAssmundsson 1/2/2014 01:30'!
convertTorrent
	torrent class = PirateTorrent ifTrue: [^self ] .
	torrent = PirateTorrent ifTrue: [^torrent:=nil ] .
	torrent isString 
		ifTrue: [torrent:={'???'. torrent. 0. 0}].
	torrent := PirateTorrent from: torrent.! !

!PirateVideo methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/17/2013 07:11'!
delete
	self deleteSubtitles.
	torrent isNil ifFalse: [torrent delete].! !

!PirateVideo methodsFor: 'subtitles' stamp: 'ChristerAssmundsson 2/15/2015 20:00'!
deleteSubtitles
	| srtName fname fs |
	torrent ifNil: [ ^ self ].
	subTitle ifNil: [ ^ self ].
	subTitle = 'dummy'
		ifTrue: [ ^ self ].
	fname := self videoFile fullVideoFilename.
	fname ifNil: [ ^ self ].
	srtName := OpenSubClient new srtFromVideo: fname.
	fs := FileDirectory forFileName: srtName.
	fs deleteFileNamed: srtName.
	subTitle := nil! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/15/2015 19:48'!
download
	torrent isNil
		ifTrue: [ ^ self ].
	self torrent download! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/24/2013 23:03'!
falseTorrents
	falseTorrents isNil
		ifTrue: [falseTorrents := OrderedCollection new].
	^ falseTorrents! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 1/2/2014 01:27'!
found
	^(self isViewed) or: [(self torrents isEmpty not) or: [videoFile isNil not]].
		! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/17/2015 21:43'!
getTopTorrent
	torrent := self torrents first.
	self download! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 3/11/2013 06:49'!
getTorrents
	self subclassResponsibility ! !

!PirateVideo methodsFor: 'subtitles' stamp: 'ChristerAssmundsson 12/31/2013 02:59'!
hasSubtitle
	^ (subTitle isNil not)! !

!PirateVideo methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/4/2013 22:41'!
icon
	^ nil! !

!PirateVideo methodsFor: 'accessing' stamp: 'ChristerAssmundsson 2/4/2013 22:41'!
id
	id isNil
		ifTrue: [^ 'undefined'].
	^ id! !

!PirateVideo methodsFor: 'accessing' stamp: 'ChristerAssmundsson 2/24/2013 22:58'!
id: aString 
	id := aString! !

!PirateVideo methodsFor: 'initialize-release' stamp: 'ChristerAssmundsson 2/15/2015 20:23'!
initialize
	super initialize.
		! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 12/28/2013 00:06'!
isDownloaded
	| |
"	self halt."
	videoFile ifNotNil: [ ^true ].
	torrent isNil ifTrue: [^ false].
	^torrent isDownloadComplete! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/25/2015 07:38'!
isDownloading
	torrent isNil
		ifTrue: [ ^ false ].
	^ torrent isDownloading! !

!PirateVideo methodsFor: 'testing' stamp: 'ChristerAssmundsson 2/15/2015 21:02'!
isViewable
	(self isViewed )ifTrue:[^false].
	
	^ self isDownloaded! !

!PirateVideo methodsFor: 'testing' stamp: 'ChristerAssmundsson 12/28/2013 00:05'!
isViewed
	viewed ifNil: [viewed:=false].
	^viewed! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/17/2015 22:14'!
lookForIt
self halt.
	torrents := self getTorrents.
	torrents := self removeFalsesFrom: torrents.
	torrents isEmpty
		ifFalse: [ 
			self getTopTorrent.
			Transcript show: self fullId , ' - Found!!'.
			Transcript cr.
			GrowlMorph openWithLabel: 'Found' contents: self fullId ].
! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/15/2015 20:51'!
lookForItIfNotFound
	self needsTorrent 
		ifTrue: [ self lookForIt ].! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 1/1/2014 03:15'!
magnet
	torrent isNil
		ifTrue: [^ ''].
	^self torrent magnet! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/15/2015 20:38'!
needsTorrent
	self isViewed
		ifTrue: [ ^ false ].
	^ videoFile isNil and: [ self torrent isNil ]! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 5/26/2014 11:38'!
newFound
	self isViewed ifTrue: [ ^false].
	^ (torrent isNil) and: [ self torrents isEmptyOrNil not ]! !

!PirateVideo methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/15/2015 19:49'!
play
	| args proc fname player |
	self isViewable ifFalse: [^self].
	player := Config current vlcFolder.
	fname := self videoFilename.
	args :=  ' --fullscreen --extraintf rc -I qt --rc-host 127.0.0.1:9092 "', fname, '" '.
	proc := OSProcess command: player , args.
	proc ifNil: [^self].
	[proc isComplete] whileFalse:
		[(Delay forMilliseconds: 200) wait.
		proc update: #runState  ].
	^ proc
! !

!PirateVideo methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/1/2014 22:44'!
play2
	| args proc fname |
	torrent ifNil:[^self].
	fname := torrent videoFilename.
"	out := FileStream forceNewFileNamed: '/tmp/deleteMe.out'.
	err := FileStream forceNewFileNamed: '/tmp/deleteMe.err'.
	desc := Array
				with: nil
				with: out
				with: err.
"	args := Array
				with: '--fullscreen'
				with: fname.
	proc := UnixProcess
				forkJob: '/usr/bin/vlc'
				arguments: args
				environment: nil
				descriptors: nil.
	proc ifNil: [UnixProcess noAccessorAvailable].
	[proc isComplete] whileFalse:
		[(Delay forMilliseconds: 200) wait.].
"	out close.
	err close."
	^ proc
"	^ self"! !

!PirateVideo methodsFor: 'printing' stamp: 'ChristerAssmundsson 2/12/2013 20:34'!
printOn: aStream 
	aStream nextPutAll:  self fullId! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/12/2013 20:32'!
removeFalseTorrent: aTorrentArray
	self falseTorrents remove: aTorrentArray.
! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/12/2013 20:33'!
removeFalsesFrom: ts 
	^ ts reject: [:t| self falseTorrents anySatisfy: [ :f | f second = t second]].! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 1/1/2014 03:16'!
removeTorrentAndData
	torrent isNil ifTrue: [^ nil].
	self torrent removeTorrentAndData! !

!PirateVideo methodsFor: 'subtitles' stamp: 'ChristerAssmundsson 12/31/2013 02:59'!
setSub: aSubtitleDict
	subTitle := aSubtitleDict .! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 1/2/2014 00:25'!
status
	| s |
	s := self statusCode .
	s= -1 ifTrue: [^ '-'].
	s=0 ifTrue: [^'Seed done'].
	s=3 ifTrue: [^'Queued'].
	s=4 ifTrue: [^'Downloading'].
	s=6 ifTrue: [^'Seeding'].
	^'x'! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 12/31/2013 03:00'!
statusCode
	| s |
	torrent isNil ifTrue: [^ -1].
	^ torrent status.
! !

!PirateVideo methodsFor: 'subtitles' stamp: 'ChristerAssmundsson 2/25/2015 07:28'!
subtitles: lang
	| subs listHash listTitle retryCount |
	retryCount := 5.
	[ 
	listHash := self subtitlesByHash: lang.
	listTitle := self subtitlesByTitle: lang ]
		on: Error
		do: [ :ex | 
			ex inspect.
			self halt.
			(retryCount := retryCount - 1) > 0
				ifTrue: [ 
					Transcript crShow: 'retrying subtitles, count left:' , retryCount printString.
					(Delay forMilliseconds: 500) wait.
					ex retry ]
				ifFalse: [ ^ #() ] ].
	subs := listHash , listTitle.
	^ subs! !

!PirateVideo methodsFor: 'subtitles' stamp: 'ChristerAssmundsson 8/24/2014 17:47'!
topSubtitles
	| os subs topSub |
	self isDownloaded
		ifFalse: [ ^ self ].
	subs := self subtitles: 'eng'.
	subs size > 0
		ifTrue: [ 
			topSub := subs first.
			os := OpenSubClient current.
			os login.
			os downloadSubtitle: topSub fileName: self videoFilename.
			[ os logout ] fork.
			Transcript crShow: 'setting subtitles for ', self fullId.
	
			self setSub: topSub ]! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 1/2/2014 01:11'!
torrent
	torrent isNil ifTrue: [^ nil].
	torrent class = PirateTorrent ifFalse: [self convertTorrent] .
	^ torrent! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 3/8/2014 23:33'!
torrent: aTorrent 
	torrent ifNotNil: [ torrent delete ].
	torrent := aTorrent.
	self changed! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/12/2013 20:31'!
torrents
	^ torrents ifNil: [torrents := OrderedCollection new]! !

!PirateVideo methodsFor: 'torrents' stamp: 'ChristerAssmundsson 2/12/2013 19:49'!
tpbString
	"tpb = The Pirate Bay "
	^ self fullId encodeForHTTP! !

!PirateVideo methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/18/2013 00:01'!
unViewed
	viewed:=false.
	self changed.
	self torrent isNil 
		ifFalse: [torrent download].
	^self! !

!PirateVideo methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/2/2014 01:41'!
videoFile
	((videoFile isNil and: [ torrent notNil ]) and: [ torrent isDownloadComplete ])
		ifTrue: [ 
			self videoFile: torrent createVideoFile.
			videoFile video: self ].
	^ videoFile! !

!PirateVideo methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/2/2014 00:55'!
videoFile: aVideoFile
	videoFile := aVideoFile .! !

!PirateVideo methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/1/2014 22:47'!
videoFilename
	^self videoFile fullVideoFilename! !

!PirateVideo methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/2/2014 01:55'!
viewed
	viewed:=true.
	self changed.
	self deleteSubtitles.
	torrent ifNotNil: [ torrent doneWithThis ].
	self videoFile ifNotNil: [ self videoFile doneWithThis ].
"	[self videoFile doneWithThis. ] forkAt: Processor userBackgroundPriority."
	^self! !

PostgresObject subclass: #PirateVideoFile
	instanceVariableNames: 'torrent video videoHash folder videoFilename swesub viewTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!PirateVideoFile methodsFor: 'hashing' stamp: 'ChristerAssmundsson 1/1/2014 22:42'!
computeHashForChunk2: fs start: start size: chunkSize
	| hash buff |
	hash := 0.
	fs position: start.
	1 to: (chunkSize // 8) do: [:i| 
		buff := fs nextLittleEndianNumber: 8.
		hash :=hash + buff.
	].
	^hash! !

!PirateVideoFile methodsFor: 'printing' stamp: 'ChristerAssmundsson 12/10/2013 03:01'!
computeHashForChunk: fs start: start size: chunkSize
	| hash buff uint |
	hash := UInt64 fromHex: '00'.
	fs position: start.
	1 to: chunkSize // 8 do: [ :i | 
		buff := fs next: 8.
		uint := UInt64 from: buff.
		hash := hash + uint ].
	^ hash! !

!PirateVideoFile methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/15/2015 20:28'!
doneWithThis
	viewTime := TimeStamp now.
	torrent isNil
		ifFalse: [ torrent doneWithThis ]! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 2/15/2015 19:32'!
fileSize
	| fs s |
	fs := self videoFile.
	fs ifNil: [ ^ nil ].
	s := fs size.
	fs close.
	^ s! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/18/2015 07:42'!
folder
	^ folder
		ifNil: [ 
			torrent isNil
				ifFalse: [ folder := torrent folder ] ]! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/18/2015 07:25'!
folder: aString
	folder:= aString! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/1/2014 16:39'!
fullVideoFilename
	| fname |
	fname := self folder , videoFilename.
	OSPlatform isUnix ifTrue: [ fname := fname copyReplaceAll: '\' with: '/' ].
	OSPlatform isWin32 ifTrue: [ fname := fname copyReplaceAll: '/' with: '\' ].
	^ fname! !

!PirateVideoFile methodsFor: 'hashing' stamp: 'ChristerAssmundsson 12/10/2013 01:54'!
getUint64From: aByteArray
	"Convert me to an Integer, least significant byte first, little endian"
	
	| integer |
	integer := 0.
	aByteArray reverse do: [ :each | 
		integer :=(integer bitShift: 8) + each ].
	^ integer! !

!PirateVideoFile methodsFor: 'hashing' stamp: 'ChristerAssmundsson 2/15/2015 19:27'!
hash2: fs
	| hashChunkSize chunkSize size head tail hash |
	fs ifNil: [ ^ nil ].
	fs binary.
	hashChunkSize := 64 * 1024.
	size := fs size.
	chunkSize := size min: hashChunkSize.
	head := self computeHashForChunk2: fs start: 0 size: chunkSize.
	tail := self computeHashForChunk2: fs start: (size - chunkSize max: 0) size: chunkSize.
	hash := (size + head + tail) asInteger.
	fs close.
	^ hash shortHexString! !

!PirateVideoFile methodsFor: 'hashing' stamp: 'ChristerAssmundsson 12/10/2013 03:01'!
hash: fs
	| hashChunkSize chunkSize size head tail hash |
	fs ifNil: [ ^ nil ].
	fs binary.
	hashChunkSize := 64 * 1024.
	size := fs size.
	chunkSize := size min: hashChunkSize.
	head := self computeHashForChunk: fs start: 0 size: chunkSize.
	tail := self computeHashForChunk: fs start: (size - chunkSize max: 0) size: chunkSize.
	hash := (size + head + tail) asInteger.
	fs close.
	^ hash printStringHex! !

!PirateVideoFile methodsFor: 'initialize-release' stamp: 'ChristerAssmundsson 11/22/2013 06:53'!
initialize
	super initialize .
	! !

!PirateVideoFile methodsFor: 'testing' stamp: 'ChristerAssmundsson 2/15/2015 19:31'!
isSeen
	video ifNil: [ ^false ] ifNotNil: [  ^video isViewed].! !

!PirateVideoFile methodsFor: 'testing' stamp: 'ChristerAssmundsson 3/18/2015 07:50'!
isValid
	^ self folder isNil not and: [ videoFilename isNil not ]! !

!PirateVideoFile methodsFor: 'printing' stamp: 'ChristerAssmundsson 12/20/2013 07:26'!
printOn: aStream 
	aStream nextPutAll:  self videoFilename ! !

!PirateVideoFile methodsFor: 'not used' stamp: 'ChristerAssmundsson 12/10/2013 03:00'!
swesub
	^ swesub ifNil: [ swesub := false ]! !

!PirateVideoFile methodsFor: 'not used' stamp: 'ChristerAssmundsson 12/10/2013 01:56'!
swesub: aBoolean
	swesub := aBoolean ! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 4/14/2014 21:39'!
torrent
	^torrent! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 11/25/2013 07:05'!
torrent: aTorrent
	torrent := aTorrent.! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/18/2015 08:08'!
validate
	self validateTorrent.
	self validateVideo! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/18/2015 07:57'!
validateTorrent
	torrent isNil
		ifFalse: [ 
			torrent isInServer not
				ifTrue: [ 
					torrent := nil.
					Transcript crShow: 'Removing torrent from: ' , self printString ] ]! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 3/18/2015 08:02'!
validateVideo
	video isNil
		ifTrue: [ ^ self ].
	self isValid
		ifFalse: [ 
			Transcript crShow: 'Disconnecting videoFile from: ' , video printString.
			video videoFile: nil.
			video := nil ]! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 12/17/2013 07:14'!
video
	^video! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 12/10/2013 03:00'!
video: aVideo
	video := aVideo! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/1/2014 23:35'!
videoFile
	| fs |
"	fd := FileDirectory on: self folder.
	fs := fd oldFileOrNoneNamed: self videoFilename ."
	fs := FileSystem disk readStreamOn: self fullVideoFilename .
	fs ifNil: [^nil].
	fs binary.
	^ fs
! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 1/1/2014 22:47'!
videoFilename
	^videoFilename ! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 11/25/2013 07:10'!
videoFilename: aString
	videoFilename := aString.! !

!PirateVideoFile methodsFor: 'hashing' stamp: 'ChristerAssmundsson 1/1/2014 03:06'!
videoHash
	^ videoHash ifNil: [ videoHash := self hash: self videoFile ]! !

!PirateVideoFile methodsFor: 'accessing' stamp: 'ChristerAssmundsson 2/15/2015 20:29'!
viewTime
	^ viewTime
		ifNil: [ 
			self isSeen
				ifTrue: [ 
					self doneWithThis.
					viewTime := TimeStamp now ] ]! !

!PostgresObject methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/17/2013 01:20'!
initialize
	super initialize.
	"uuid := UUID new."! !

!PostgresObject methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/17/2013 01:22'!
save
	uuid isNil 
		ifTrue: [
			uuid := UUID new.
			]
		ifFalse: [  ].! !

!PostgresObject methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/17/2013 01:20'!
uuid
	^uuid "ifNil: [uuid := UUID new.]"! !

Object subclass: #TransmissionClient
	instanceVariableNames: 'xSessionId'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!TransmissionClient class methodsFor: 'as yet unclassified' stamp: 'CAs 7/7/2012 09:04'!
current
	Current isNil
		ifTrue: [Current := self new]. 
	^ Current! !

!TransmissionClient class methodsFor: 'as yet unclassified' stamp: 'CAs 7/7/2012 09:34'!
new
^ super new initialize! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/17/2015 21:13'!
addTorrent: aTorrentString
	"a torrent-URL or a magnet-link"

	| args req |
	args := Dictionary new.
	args at: 'filename' put: aTorrentString.
	args at: 'download-dir' put: self folder.
	req := Dictionary new.
	req at: 'method' put: 'torrent-add'.
	req at: 'arguments' put: args.
	^ self sendReq: req! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/17/2015 21:16'!
folder
	| folder transFolder sep |
	transFolder := self getDownloadDir.
	(Path isAbsoluteUnixPath: transFolder)
		ifTrue: [ sep := '/' ].
	(Path isAbsoluteWindowsPath: transFolder)
		ifTrue: [ sep := '\' ].
	folder := transFolder , sep , '_TvProgram'.
	^ folder! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:12'!
getAll
	| args req resp t torrents |
	args := Dictionary new.
	args at: 'fields' put: {'id'. 'name'. 'totalSize'. 'files'. 'percentDone'. 'hashString'. 'status'} .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	^torrents := (resp at: #arguments) at: #torrents! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:14'!
getDir: aTorrentId
	| args req resp ts |
	args := Dictionary new.
	args at: 'ids'	put: (Array with: aTorrentId ). 
	args at: 'fields' put: {'id'. 'name'. 'downloadDir'. 'totalSize'. 'files'. 'percentDone'. 'hashString'} .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	ts := (resp at: #arguments) at: #torrents.
	ts isEmptyOrNil ifTrue: [^#()].
	^ ts first at: #downloadDir.
	! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/17/2015 07:26'!
getDownloadDir
	| args req resp dir |
	args := Dictionary new.
	req := Dictionary new.
	req at: 'method' put: 'session-get'.
	req at: 'arguments' put: args.
	
	resp := self sendReq: req.
	dir := (resp at: #arguments) at: 'download-dir'.
	^ dir ! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:14'!
getFiles: aTorrentId
	| args req resp ts |
	args := Dictionary new.
	args at: 'ids'	put: (Array with: aTorrentId ). 
	args at: 'fields' put: {'id'. 'name'. 'downloadDir'. 'totalSize'. 'files'. 'percentDone'. 'hashString'} .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	ts := (resp at: #arguments) at: #torrents.
	ts isEmptyOrNil ifTrue: [^#()].
	^ ts first at: #files.
	! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:15'!
getMagnet: aTorrentId
	| args req resp ts |
	args := Dictionary new.
	args at: 'ids'	put: (Array with: aTorrentId ). 
	args at: 'fields' put: { 'magnetLink' } .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	ts := (resp at: #arguments) at: #torrents.
	ts isEmptyOrNil ifTrue: [^#()].
	^ ts first at: #magnetLink.
	! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:15'!
getStatus: aTorrentId
	| args req resp ts |
	args := Dictionary new.
	args at: 'ids'	put: (Array with: aTorrentId ). 
	args at: 'fields' put: {'id'. 'status'. } .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	ts := (resp at: #arguments) at: #torrents.
	ts isEmptyOrNil ifTrue: [^#()].
	^ ts first at: #status.
	! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/16/2015 21:15'!
getTitle: aTorrentId
	| args req resp ts |
	args := Dictionary new.
	args at: 'ids'	put: (Array with: aTorrentId ). 
	args at: 'fields' put: { 'name' } .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	ts := (resp at: #arguments) at: #torrents.
	ts isEmptyOrNil ifTrue: [^nil].
	^ ts first at: #name.
	! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:15'!
getTorrents
	"a torrent-URL or a magnet-link"
	| args req |
	args := Dictionary new.
	args at: 'fields' put: #('id' 'name' 'isFinished' 'downloadDir' 'magnetLink' 'files' ).
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args. 
	^ ((self sendReq: req)
		at: 'arguments') at: 'torrents'! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:15'!
getTotalSize: aTorrentId
	| args req resp ts |
	args := Dictionary new.
	args at: 'ids'	put: (Array with: aTorrentId ). 
	args at: 'fields' put: {'id'.  'totalSize'. } .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	ts := (resp at: #arguments) at: #torrents.
	ts isEmptyOrNil ifTrue: [^#()].
	^ ts first at: #totalSize.
	! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/17/2013 23:35'!
initialize
	xSessionId :='dummy' .
! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:16'!
isComplete: aTorrentId 
	| args req resp t torrents |
	args := Dictionary new.
	args
		at: 'ids'
		put:  aTorrentId .
"		put: 'recently-active'."
	args at: 'fields' put: {'id'. 'totalSize'. 'leftUntilDone'. 'isFinished'. 'percentDone'. 'status'} .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	torrents := (resp at: #arguments) at: #torrents.
	torrents isEmpty ifTrue: [^false].
	t := torrents first.
	( t at: #totalSize)= 0 ifTrue: [ ^false ].
	Transcript show: (t at: #status).
	^ 0 = (t at: #leftUntilDone).! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:16'!
isHashInServer: aMagnet
	| args req resp torrents |
	args := Dictionary new.
	args
		at: 'ids'
		put:  aMagnet .
"		put: 'recently-active'."
	args at: 'fields' put: {'id'. 'leftUntilDone'. 'isFinished'. 'percentDone'. 'status'} .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	torrents := (resp at: #arguments) at: #torrents.
	^torrents isEmpty not.! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:16'!
isMagnetInServer: aHash
	| args req resp torrents |
	args := Dictionary new.
	args
		at: 'ids'
		put:  aHash .
"		put: 'recently-active'."
	args at: 'fields' put: {'id'. 'leftUntilDone'. 'isFinished'. 'percentDone'. 'status'} .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	torrents := (resp at: #arguments) at: #torrents.
	^torrents isEmpty not.! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:16'!
isSeedingComplete: aTorrentId
	| args req resp t torrents maxSeedTime |
	maxSeedTime := 90*24*60*60.
	args := Dictionary new.
	args at: 'ids' put: aTorrentId.	"		put: 'recently-active'."
	args
		at: 'fields'
		put:
			{'id'.
			'totalSize'.
			'leftUntilDone'.
			'isFinished'.
			'percentDone'.
			'secondsSeeding'.
			'status'}.
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.	"^"
	resp := self sendReq: req.
	torrents := (resp at: #arguments) at: #torrents.
	torrents isEmpty
		ifTrue: [ ^ true ].
	t := torrents first.
	(t at: #totalSize) = 0
		ifTrue: [ ^ false ].
	(t at: #secondsSeeding) > maxSeedTime
		ifTrue: [ ^ true ].
	^ 0 = (t at: #status)! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:16'!
isTorrentInServer: aHash
	| args req resp torrents |
	args := Dictionary new.
	args
		at: 'ids'
		put:  aHash .
"		put: 'recently-active'."
	args at: 'fields' put: {'id'. 'leftUntilDone'. 'isFinished'. 'percentDone'. 'status'} .
	req := Dictionary new.
	req at: 'method' put: 'torrent-get'.
	req at: 'arguments' put: args.
	"^" 
	resp:=self sendReq: req .
	torrents := (resp at: #arguments) at: #torrents.
	^torrents isEmpty not.! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/12/2015 07:29'!
newRequest: aString
	| request anURL |
	anURL := 'http://' , Config current host , ':' , Config current port asString , '/transmission/rpc'.
	request := ZnClient new
		timeout: 10;
		numberOfRetries: 3;
		retryDelay: 2;
		beOneShot.
	request url: anURL.
	request contents: aString.
	request headerAt: 'x-transmission-session-id' put: xSessionId asString.
	^ request! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:16'!
removeTorrent: aTorrentId 
	| args req |
	args := Dictionary new.
	args
		at: 'ids'
		put: (Array with: aTorrentId ). 
	args at: 'delete-local-data' put: 'true'.
	req := Dictionary new.
	req at: 'method' put: 'torrent-remove'.
	req at: 'arguments' put: args.
	^ self sendReq: req ! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:17'!
removeTorrentX: aTorrentId 
	| args req |
	args := Dictionary new.
	args
		at: 'ids'
		put: (Array with: aTorrentId ). 
	args at: 'delete-local-data' put: 'true'.
	req := Dictionary new.
	req at: 'method' put: 'torrent-remove'.
	req at: 'arguments' put: args.
	^ self sendReq: req ! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 5/20/2014 17:05'!
sendReq: aJSON
	| request resp reqString |
	(aJSON isKindOf: String)
		ifTrue: [ reqString := aJSON ]
		ifFalse: [ reqString :=NeoJSONWriter toString: aJSON ].	"		ifFalse: [reqString := Json render: aJSON].
"
	request := self newRequest: reqString.
	request post.
	request response code = 409
		ifTrue: [ 
			self setSessionIdFrom: request.
			request := self newRequest: reqString.
			request post ].	"	resp := Json readFrom: request contents readStream.
"
	resp := NeoJSONReader fromString: request contents readStream.
	^ resp! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'CAs 7/7/2012 09:40'!
setSessionIdFrom: aRequest 
	| headers | 
	headers := aRequest response headers.
	(headers includesKey: 'x-transmission-session-id')
		ifTrue: [xSessionId := headers at: 'x-transmission-session-id']! !

!TransmissionClient methodsFor: 'as yet unclassified' stamp: 'CAs 7/7/2012 09:25'!
test
	| req |
	host := 'cm1'.
	port := 9091.
	req := '{ 
	         "arguments": {
	             "fields": [ "id", "name", "totalSize" ],
	             "ids": [ 7, 10 ]
	         },
	         "method": "torrent-get",
	         "tag": 39693
	      }'.
"	self halt."
	^self sendReq: req! !

Object subclass: #UInt64
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate'!

!UInt64 commentStamp: 'CAs 7/14/2012 07:40' prior: 0!
Very basic functions for Unsigned 64-bit integer.
Read and stored as little endian!

!UInt64 class methodsFor: 'as yet unclassified' stamp: 'CAs 7/13/2012 00:19'!
from: aByteArray
	^self new bytes: aByteArray! !

!UInt64 class methodsFor: 'as yet unclassified' stamp: 'CAs 7/14/2012 08:30'!
fromHex: aHexString
	| b |
	b := ByteArray readHexFrom: aHexString.
	^ self from: b.
! !

!UInt64 methodsFor: 'as yet unclassified' stamp: 'CAs 7/14/2012 23:08'!
+ term
	| r c a b s |
	r := ByteArray new: 8.
	c := 0.
	1 to: 8 do: [:i| 
		a:=(bytes at: i).
		b := (term bytes at:  i) .
		s := a+b+c.
		r at: i put: (s bitAnd: 16rff).
		c := s >> 8.
	].
	^ UInt64 from: r.! !

!UInt64 methodsFor: 'as yet unclassified' stamp: 'CAs 7/14/2012 08:38'!
= uint
	1 to: 8 do: [:i| (bytes at: i) = (uint bytes at:  i) ifFalse: [ ^false ]].
	
	^ true.! !

!UInt64 methodsFor: 'as yet unclassified' stamp: 'CAs 7/15/2012 12:09'!
adaptToInteger: rcvr andSend: selector
	"If I am involved in arithmetic with an Integer, convert myself to Integer."
	^ rcvr  perform: selector with: self asInteger ! !

!UInt64 methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/1/2014 22:41'!
asHex

	^ self asInteger printStringHex ! !

!UInt64 methodsFor: 'as yet unclassified' stamp: 'CAs 7/14/2012 08:27'!
asInteger
	| accum |
	accum := 0.
	8 to: 1 by: -1do: [:i| accum :=(accum bitShift: 8) + (bytes at: i) ].
	^ accum! !

!UInt64 methodsFor: 'as yet unclassified' stamp: 'CAs 7/14/2012 08:38'!
bytes
	^bytes! !

!UInt64 methodsFor: 'as yet unclassified' stamp: 'CAs 7/15/2012 10:56'!
bytes: aByteArray
	bytes := ByteArray new: 8.
	1 to: (aByteArray size min: 8) do: [:i| bytes at: i put: (aByteArray at:  i)].
	^ self! !

!UInt64 methodsFor: 'as yet unclassified' stamp: 'CAs 7/15/2012 10:57'!
printOn: aStream 
	aStream nextPutAll:  'Uint64(', self asHex, ')'! !
PirateShow initialize!
PirateApp initialize!
